/// <reference types="react" />
import type { CellRendererProps, SharedEditorProps, Omit } from './types';
type SharedCellRendererProps<R, SR> = Pick<CellRendererProps<R, SR>, 'rowIdx' | 'row' | 'column'>;
interface EditCellProps<R, SR> extends SharedCellRendererProps<R, SR>, Omit<React.HTMLAttributes<HTMLDivElement>, 'style' | 'children'> {
    editorProps: SharedEditorProps<R>;
    width: number | undefined;
}
export default function EditCell<R, SR>({ className, column, row, rowIdx, width, editorProps, ...props }: EditCellProps<R, SR>): import("react").JSX.Element;
export {};
//# sourceMappingURL=EditCell.d.ts.map