'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const React = require('react');
const clsx = require('clsx');
const lodash = require('lodash');
const jsxRuntime = require('react/jsx-runtime');
const resizeObserver = require('@juggle/resize-observer');
const inRange = require('lodash/inRange');
const icons = require('@ant-design/icons');
const antd = require('antd');
const reactDnd = require('react-dnd');
const copyToClipboard = require('copy-to-clipboard');
const reactDom = require('react-dom');
const Menu = require('rc-menu');

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z$i = ".cj343x0{background-color:inherit;border-bottom:1px solid var(--border-color);border-right:1px solid var(--border-color);contain:strict;contain:size layout style paint;overflow:hidden;overflow:clip;padding:0 8px;position:relative;text-overflow:ellipsis;white-space:nowrap}.csofj7r{position:-webkit-sticky;position:sticky;z-index:1}.ch2wcw8{box-shadow:2px 0 5px -2px #8888884d}.c1wvphzh.rdg-cell.rdg-cell-selected{background:var(--row-selected-background-color);color:var(--selected-color)}";
styleInject(css_248z$i);

const cell = "cj343x0";
const cellClassname = `rdg-cell ${cell}`;
const cellFrozen = "csofj7r";
const cellFrozenClassname = `rdg-cell-frozen ${cellFrozen}`;
const cellFrozenLast = "ch2wcw8";
const cellFrozenLastClassname = `rdg-cell-frozen-last ${cellFrozenLast}`;
const cellSelected = "c1wvphzh";
const cellSelectedClassname = `rdg-cell-selected ${cellSelected}`;

var css_248z$h = ".rnvodz5{--brand-blue1-color:#d6e4ff;--brand-blue2-color:#bae7ff;--brand-blue2-color-value:186,231,255;--brand-blue3-color:#91d5ff;--brand-blue5-color:#40a9ff;--brand-blue6-color:#006aff;--brand-blue7-color:#096dd9;--brand-blue7-color-value:9,109,217;--neutral-grey0-color-value:31,41,61;--neutral-grey1-color:#f7f9fb;--neutral-grey2-color:#f3f6fc;--neutral-grey3-color:#f0f2f5;--neutral-grey4-color:#e2e8f3;--neutral-White6-color:#ffffff0f;--neutral-White20-color:#434343;--neutral-White30-color:#ffffff4d;--neutral-White50-color:#ffffff80;--neutral-White65-color:#ffffffa6;--neutral-White85-color:#ffffffd9;--neutral-White100-color:#fff;--neutral-black45-color:#00000073;--function-green2-color:#d9f7be;--function-green3-color:#b7eb8f;--function-green6-color:#52c41a;--function-green6-color-value:82,196,26;--green-8-color-value:35,120,4;--function-gold2-color:#fff1b8;--function-gold2-color-value:255,241,184;--function-gold3-color:#ffe58f;--function-gold6-color:#faad14;--function-gold6-color-value:250,173,20;--function-gold8-color:#ad6800;--function-red2-color:#ffccc7;--function-red2-color-value:255,204,199;--function-red3-color:#ffa39e;--function-red3-color-value:255,163,158;--function-red6-color:#f5222d;--function-red6-color-value:245,34,45;--function-red8-color:#a8071a;--function-red8-color-value:168,7,26;--code-normal-color:#000000d9;--code-blue-color:#00f;--code-green-color:#09885a;--code-red-color:red;--icon-blue-color:#40a9ff;--icon-geekblue-color:#597ef7;--icon-cyan-color:#36cfc9;--icon-green-color:#73d13d;--icon-purple-color:#9254de;--icon-magenta-color:#f759ab;--icon-orange-color:#ffa940;--icon-yellow-color:#ffec3d;--background-normal-color:var(--neutral-grey3-color);--background-primary-color:var(--neutral-White100-color);--background-secondry-color:var(--neutral-White100-color);--background-tertraiy-color:var(--neutral-grey1-color);--navigation-background-color:var(--neutral-grey0-color);--tab-background-color:var(--neutral-grey2-color);--dropdown-background-color:var(--neutral-White100-color);--tooltips-background-color:#000000bf;--mask-color:#00000040;--hover-color:#0000000f;--divider-color:var(--neutral-grey4-color);--odc-border-color:var(--neutral-grey4-color);--text-color-primary:#132039;--text-color-secondary:#000000a6;--text-color-hint:#00000080;--text-color-placeholder:#0000004d;--text-color-inverse:#000;--text-color-link:var(--brand-blue6-color);--text-color-error:var(--function-red6-color);--icon-color-normal:#000000a6;--icon-color-focus:var(--brand-blue6-color);--icon-color-disable:#00000040;--icon-color-1:var(--icon-blue-color);--icon-color-2:var(--icon-green-color);--icon-color-3:var(--icon-orange-color);--icon-color-4:var(--icon-magenta-color);--icon-color-5:var(--icon-purple-color);--icon-color-6:var(--icon-cyan-color);--icon-color-7:var(--icon-yellow-color);--icon-color-8:var(--icon-geekblue-color);--table-border-color:var(--border-color);--table-header-background-color:var(--neutral-grey2-color);--table-focus-color:var(--brand-blue1-color);--table-hover-color:var(--brand-blue6-color);--table-new-color:rgba(var(--function-green6-color-value),0.25);--table-edit-color:rgba(var(--function-gold6-color-value),0.25);--table-delete-color:rgba(var(--function-red3-color-value),0.25);--code-common-color:var(--text-color-primary);--code-comment-color:var(--code-green-color);--code-keyword-color:var(--code-blue-color);--code-number-color:var(--code-red-color);--code-string-color:var(--code-red-color);--code-background-selected-color:rgba(var(--brand-blue2-color-value),0.65);--code-background-highlight-color:rgba(var(--function-gold2-color-value),0.65);--code-background-error-color:rgba(var(--function-red2-color-value),0.65);--selected-color:#fff;--color:var(--text-color-primary);--border-color:var(--odc-border-color);--background-color:var(--background-primary-color);--header-background-color:var(--table-header-background-color);--row-hover-background-color:var(--table-focus-color);--row-selected-background-color:var(--table-hover-color);--row-selected-cell-background-color:var(--table-hover-color);--row-selected-hover-background-color:var(--table-focus-color);--selection-color:#66afe9;--font-size:12px;background-color:var(--background-color);box-sizing:border-box;color:var(--color);contain:strict;contain:size layout style paint;content-visibility:auto;font-size:var(--font-size);height:350px;outline:1px solid var(--border-color);overflow:auto;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.rnvodz5.rdg-dark{--brand-blue1-color:#111d2c;--brand-blue2-color-value:27,47,68;--brand-blue2-color:#1b2f44;--brand-blue3-color:#203e5a;--brand-blue5-color:#1a66ac;--brand-blue6-color:#167cdb;--brand-blue7-color:#3895eb;--brand-blue7-color-value:56,149,235;--neutral-grey0-color-value:18,19,20;--neutral-grey1-color:#1c1d1f;--neutral-grey2-color:#26292b;--neutral-grey3-color:#2d3033;--neutral-grey4-color:#363a3d;--neutral-White6-color:#ffffff0f;--neutral-White20-color:#434343;--neutral-White30-color:#ffffff4d;--neutral-White50-color:#ffffff80;--neutral-White65-color:#ffffffa6;--neutral-White85-color:#ffffffd9;--neutral-White100-color:#fff;--neutral-black45-color:#00000073;--function-green2-color:#1d371266;--function-green3-color:#274916;--function-green6-color:#49aa19;--green-8-color-value:143,212,96;--function-gold2-color:#44311166;--function-gold3-color:#594214;--function-gold6-color:#d89614;--function-gold8-color:#d8961466;--function-red2-color:#43141866;--function-red3-color:#58181c;--function-red6-color:#d32029;--function-red8-color:#f3737066;--function-red8-color-value:243,115,112;--code-normal-color:#ffffffd9;--code-blue-color:#5099fb;--code-green-color:#98d782;--code-red-color:#e47d8d;--icon-blue-color:#509de6;--icon-geekblue-color:#5069e6;--icon-cyan-color:#59b3af;--icon-green-color:#81b350;--icon-purple-color:#a179f2;--icon-magenta-color:#d96ca5;--icon-orange-color:#d9924c;--icon-yellow-color:#e8d639;--background-normal-color:var(--neutral-grey2-color);--background-primary-color:var(--neutral-grey1-color);--background-secondry-color:var(--neutral-grey2-color);--background-tertraiy-color:var(--neutral-grey3-color);--navigation-background-color:var(--neutral-grey4-color);--tab-background-color:var(--neutral-grey4-color);--dropdown-background-color:var(--neutral-grey4-color);--tooltips-background-color:var(--neutral-grey4-color);--mask-color:#000000a6;--hover-color:#fff9;--divider-color:rgba(var(--neutral-grey0-color-value),0.65);--odc-border-color:var(--neutral-grey4-color);--text-color-primary:#ffffffd9;--text-color-secondary:#ffffffa6;--text-color-hint:#ffffff80;--text-color-placeholder:#ffffff4d;--text-color-inverse:#fff;--text-color-link:var(--brand-blue6-color);--text-color-error:var(--function-red6-color);--icon-color-normal:#ffffffa6;--icon-color-focus:var(--brand-blue6-color);--icon-color-disable:#ffffff4d;--icon-color-1:var(--icon-blue-color);--icon-color-2:var(--icon-green-color);--icon-color-3:var(--icon-orange-color);--icon-color-4:var(--icon-magenta-color);--icon-color-5:var(--icon-purple-color);--icon-color-6:var(--icon-cyan-color);--icon-color-7:var(--icon-yellow-color);--icon-color-8:var(--icon-geekblue-color);--table-border-color:var(--border-color);--table-header-background-color:var(--neutral-grey3-color);--table-focus-color:var(--brand-blue2-color);--table-hover-color:var(--brand-blue6-color);--table-new-color:rgba(var(--green-8-color-value),0.4);--table-edit-color:var(--function-gold8-color);--table-delete-color:var(--function-red8-color);--code-common-color:var(--text-color-primary);--code-comment-color:var(--code-green-color);--code-keyword-color:var(--code-blue-color);--code-number-color:var(--code-red-color);--code-string-color:var(--code-red-color);--code-background-selected-color:rgba(var(--brand-blue7-color-value),0.5);--code-background-highlight-color:rgba(var(--green-8-color-value),0.12);--code-background-error-color:rgba(var(--function-red8-color-value),0.12)}@supports not (contain:strict){.rnvodz5{position:relative;z-index:0}}.rnvodz5 *,.rnvodz5 :after,.rnvodz5 :before{box-sizing:inherit}.flqv91k{height:0;left:0;outline:0;position:-webkit-sticky;position:sticky;top:0;width:0}.v1lsfrzw.r1upfr80{cursor:move}";
styleInject(css_248z$h);

const root = "rnvodz5";
const rootClassname = `rdg ${root}`;
const focusSink = "flqv91k";
const focusSinkClassname = `rdg-focus-sink ${focusSink}`;
const viewportDragging = "v1lsfrzw";
const viewportDraggingClassname = `rdg-viewport-dragging ${viewportDragging}`;

var css_248z$g = ".gajh8w5:not(.ry99me){background-color:var(--header-background-color)}.gajh8w5>.cj343x0:not(:last-child):not(.ch2wcw8){border-right:none}.g17pnute:after{bottom:0;box-shadow:inset 0 0 0 2px var(--selection-color);content:\"\";left:0;pointer-events:none;position:absolute;right:0;top:0;z-index:2}.g17pnute>.cj343x0:first-child{box-shadow:inset 2px 0 0 0 var(--selection-color)}";
styleInject(css_248z$g);

const groupRowSelected = "g17pnute";
const groupRowSelectedClassname = `rdg-group-row-selected ${groupRowSelected}`;

var css_248z$f = ".hz5s9zk{-ms-grid-columns:var(--template-columns);contain:strict;contain:size layout style paint;display:-ms-grid;display:grid;font-weight:700;grid-template-columns:var(--template-columns);position:-webkit-sticky;position:sticky;width:var(--row-width);z-index:3}.h194p35a{-ms-grid-rows:var(--header-row-height);grid-template-rows:var(--header-row-height);height:var(--header-row-height);line-height:var(--header-row-height);top:0;touch-action:none}.fy91evj{-ms-grid-rows:var(--filter-row-height);grid-template-rows:var(--filter-row-height);height:var(--filter-row-height);line-height:var(--filter-row-height);top:var(--header-row-height)}";
styleInject(css_248z$f);

const headerRowAndFilterRow = "hz5s9zk";
const headerRow = "h194p35a";
const headerRowClassname = `rdg-header-row ${headerRowAndFilterRow} ${headerRow}`;

var css_248z$e = ".r1upfr80{-ms-grid-rows:var(--row-height);-ms-grid-columns:var(--template-columns);background-color:var(--background-color);color:var(--color);contain:strict;contain:size layout style paint;display:-ms-grid;display:grid;grid-template-columns:var(--template-columns);grid-template-rows:var(--row-height);height:var(--row-height);left:0;line-height:var(--row-height);position:absolute;width:var(--row-width)}.r190mhd3.rdg-row{contain:none}.r139qu9m.rdg-row{background-color:var(--table-new-color)}.rm1sydw.rdg-row{background-color:var(--table-delete-color)}.ry99me.rdg-row-selected.rdg-row{background-color:var(--row-selected-background-color);color:var(--selected-color)}.ry99me.rdg-row-selected.rdg-row .rdg-cell{background-color:var(--row-selected-cell-background-color);color:var(--selected-color)}.sj8n0qv{-ms-grid-rows:var(--summary-row-height);grid-template-rows:var(--summary-row-height);height:var(--summary-row-height);line-height:var(--summary-row-height);position:-webkit-sticky;position:sticky;z-index:3}.lx6ugue .rdg-cell{border-bottom-width:2px}.duzpn72:before{background:var(--row-selected-background-color);content:\"\";height:2px;position:absolute;top:0;width:100%;z-index:1}.dvp3c88{opacity:.6}.r1n2ajof{height:100%;left:0;pointer-events:none;position:absolute;width:100%}.t1ncply6 .ant-popover-arrow{display:none}.t1ncply6 .ant-popover-inner-content{padding:0 0 0 10px}.t1ncply6 .ant-popover-inner{background-color:initial;box-shadow:unset}.t1ncply6.ant-popover{padding-top:0}.r13ljn0a.rdg-row>.rdg-cell div:first-child{font-weight:700}";
styleInject(css_248z$e);

const row = "r1upfr80";
const rowCellShowMenuClassname = "r190mhd3";
const rowClassname = `rdg-row ${row}`;
const rowIsAddClassname = "r139qu9m";
const rowIsDeleteClassname = "rm1sydw";
const rowSelected = "ry99me";
const rowSelectedClassname = `rdg-row-selected ${rowSelected}`;
const summaryRow = "sj8n0qv";
const lastSummaryRowClassname = "lx6ugue";
const summaryRowClassname = `rdg-summary-row ${summaryRow}`;
const dropOverRowClassName = "duzpn72";
const dragingRowClassName = "dvp3c88";
const rdgDragPreviewClassname = "r1n2ajof";
const rowMainSelectClassname = "r13ljn0a";

function useFocusRef(isCellSelected) {
  const ref = React.useRef(null);
  React.useLayoutEffect(() => {
    var _ref$current;
    if (!isCellSelected) return;
    (_ref$current = ref.current) == null || _ref$current.focus({
      preventScroll: true
    });
  }, [isCellSelected]);
  return ref;
}

var css_248z$d = ".c4l3n6v{-webkit-box-align:center;-ms-flex-align:center;-webkit-box-pack:center;-ms-flex-pack:center;-webkit-align-items:center;align-items:center;bottom:0;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-justify-content:center;justify-content:center;left:0;margin-right:1px;position:absolute;right:0;top:0}.c1bikpmb{all:unset;margin:0;width:0}.c1eyot7g{background-color:var(--background-color);border:2px solid var(--border-color);content:\"\";height:20px;width:20px}.c1bikpmb:checked+.c1eyot7g{background-color:var(--checkbox-color);box-shadow:inset 0 0 0 4px var(--background-color)}.c1bikpmb:focus+.c1eyot7g{border-color:var(--checkbox-focus-color)}.c1jlcvp4{cursor:default}.c1jlcvp4 .c1eyot7g{background-color:var(--checkbox-disabled-background-color);border-color:var(--checkbox-disabled-border-color)}";
styleInject(css_248z$d);

const checkboxLabel = "c4l3n6v";
const checkboxLabelClassname = `rdg-checkbox-label ${checkboxLabel}`;
const checkboxInput = "c1bikpmb";
const checkboxInputClassname = `rdg-checkbox-input ${checkboxInput}`;
const checkbox = "c1eyot7g";
const checkboxClassname = `rdg-checkbox ${checkbox}`;
const checkboxLabelDisabled = "c1jlcvp4";
const checkboxLabelDisabledClassname = `rdg-checkbox-label-disabled ${checkboxLabelDisabled}`;
function SelectCellFormatter({
  value,
  tabIndex,
  isCellSelected,
  disabled,
  onClick,
  onChange,
  aria
}) {
  const inputRef = useFocusRef(isCellSelected);
  function handleChange(e) {
    onChange(e.target.checked, e.nativeEvent.shiftKey);
  }
  return /*#__PURE__*/jsxRuntime.jsxs("label", {
    className: clsx(checkboxLabelClassname, disabled && checkboxLabelDisabledClassname),
    children: [/*#__PURE__*/jsxRuntime.jsx("input", {
      ...aria,
      tabIndex: tabIndex,
      ref: inputRef,
      type: "checkbox",
      className: checkboxInputClassname,
      disabled: disabled,
      checked: value,
      onChange: handleChange,
      onClick: onClick
    }), /*#__PURE__*/jsxRuntime.jsx("div", {
      className: checkboxClassname
    })]
  });
}

const ValueFormatter = /*#__PURE__*/React.memo(function ValueFormatter(props) {
  try {
    return /*#__PURE__*/jsxRuntime.jsx(jsxRuntime.Fragment, {
      children: props.row[props.column.key]
    });
  } catch (e) {
    return null;
  }
}, (prevProps, nextProps) => prevProps.row === nextProps.row && prevProps.column === nextProps.column);

var css_248z$c = ".g1vzro7t{outline:none}.c1fsqdic{stroke:currentColor;stroke-width:1.5px;fill:#0000;margin-left:4px;vertical-align:middle}.c1fsqdic>path{-webkit-transition:d .1s;transition:d .1s}";
styleInject(css_248z$c);

const groupCellContent = "g1vzro7t";
const groupCellContentClassname = `rdg-group-cell-content ${groupCellContent}`;
const caret = "c1fsqdic";
const caretClassname = `rdg-caret ${caret}`;
function ToggleGroupFormatter({
  groupKey,
  isExpanded,
  isCellSelected,
  toggleGroup
}) {
  const cellRef = useFocusRef(isCellSelected);
  function handleKeyDown({
    key
  }) {
    if (key === 'Enter') {
      toggleGroup();
    }
  }
  const d = isExpanded ? 'M1 1 L 7 7 L 13 1' : 'M1 7 L 7 1 L 13 7';
  return /*#__PURE__*/jsxRuntime.jsxs("span", {
    ref: cellRef,
    className: groupCellContentClassname,
    tabIndex: -1,
    onKeyDown: handleKeyDown,
    children: [groupKey, /*#__PURE__*/jsxRuntime.jsx("svg", {
      viewBox: "0 0 14 8",
      width: "14",
      height: "8",
      className: caretClassname,
      children: /*#__PURE__*/jsxRuntime.jsx("path", {
        d: d
      })
    })]
  });
}

const nonInputKeys = new Set(['Unidentified', 'Alt', 'AltGraph', 'CapsLock', 'Control', 'Fn', 'FnLock', 'Meta', 'NumLock', 'ScrollLock', 'Shift', 'Tab', 'ArrowDown', 'ArrowLeft', 'ArrowRight', 'ArrowUp', 'End', 'Home', 'PageDown', 'PageUp', 'Insert', 'ContextMenu', 'Escape', 'Pause', 'Play', 'PrintScreen', 'F1', 'F3', 'F4', 'F5', 'F6', 'F7', 'F8', 'F9', 'F10', 'F11', 'F12']);
function isCtrlKeyHeldDown(e) {
  return (e.ctrlKey || e.metaKey) && e.key !== 'Control';
}
function isDefaultCellInput(event) {
  return !nonInputKeys.has(event.key);
}
function onEditorNavigation({
  key,
  target
}) {
  if (key === 'Tab' && (target instanceof HTMLInputElement || target instanceof HTMLTextAreaElement || target instanceof HTMLSelectElement)) {
    return target.matches('.rdg-editor-container > :only-child, .rdg-editor-container > label:only-child > :only-child');
  }
  return false;
}
function isCtrlDown(event) {
  var isMac = /macintosh|mac os x/i.test(navigator.userAgent);
  return isMac ? event.metaKey : event.ctrlKey;
}

function isCellEditable({
  column,
  row
}) {
  return (column == null ? void 0 : column.editor) != null && (typeof (column == null ? void 0 : column.editable) === 'function' ? column == null ? void 0 : column.editable(row) : column == null ? void 0 : column.editable) !== false;
}
function getNextSelectedCellPosition({
  cellNavigationMode,
  columns,
  rows,
  nextPosition
}) {
  const rowsCount = rows.length;
  let position = nextPosition;
  if (cellNavigationMode !== 'NONE') {
    const {
      columnIdx,
      rowIdx
    } = nextPosition;
    const columnsCount = columns.length;
    const isAfterLastColumn = columnIdx === columnsCount;
    const isBeforeFirstColumn = columnIdx === -1;
    if (isAfterLastColumn) {
      if (cellNavigationMode === 'CHANGE_ROW') {
        const isLastRow = rowIdx === rowsCount - 1;
        if (!isLastRow) {
          position = {
            columnIdx: 0,
            rowIdx: rowIdx + 1
          };
        }
      } else {
        position = {
          rowIdx,
          columnIdx: 0
        };
      }
    } else if (isBeforeFirstColumn) {
      if (cellNavigationMode === 'CHANGE_ROW') {
        const isFirstRow = rowIdx === 0;
        if (!isFirstRow) {
          position = {
            rowIdx: rowIdx - 1,
            columnIdx: columnsCount - 1
          };
        }
      } else {
        position = {
          rowIdx,
          columnIdx: columnsCount - 1
        };
      }
    }
  }
  return position;
}
function canExitGrid({
  cellNavigationMode,
  columns,
  rowsCount,
  selectedRange: {
    rowIdx,
    columnIdx
  },
  shiftKey
}) {
  if (cellNavigationMode === 'NONE' || cellNavigationMode === 'CHANGE_ROW') {
    const atLastCellInRow = columnIdx === columns.length - 1;
    const atFirstCellInRow = columnIdx === 0;
    const atLastRow = rowIdx === rowsCount - 1;
    const atFirstRow = rowIdx === 0;
    return shiftKey ? atFirstCellInRow && atFirstRow : atLastCellInRow && atLastRow;
  }
  return false;
}

function getCellStyle(column) {
  return {
    gridColumnStart: column.idx + 1,
    left: column.frozen ? `var(--frozen-left-${column.key})` : undefined
  };
}
function getCellClassname(column, ...extraClasses) {
  return clsx(cellClassname, ...extraClasses, column.frozen && cellFrozenClassname, column.isLastFrozenColumn && cellFrozenLastClassname);
}
const generateUniqKey = function () {
  let key = 0;
  return function (suffixStr = '') {
    key = key + 1;
    return `${key}-${Date.now()}-${~~(Math.random() * 10000)}-${suffixStr || ''}`;
  };
}();

var css_248z$b = ".r17o28l0{-webkit-box-align:center;-ms-flex-align:center;-webkit-box-pack:end;-ms-flex-pack:end;-webkit-align-items:center;align-items:center;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;font-size:12px;-webkit-justify-content:flex-end;justify-content:flex-end;padding-right:5px}.snfadq1{background:var(--row-selected-hover-background-color);color:var(--color)}";
styleInject(css_248z$b);

const rowIndexCellClassName$1 = "r17o28l0";
const selectedClassName = "snfadq1";
const RowIndexCellFormatter = function (props) {
  const {
    isRowSelected,
    onRowSelectionChange,
    rowIdx
  } = props;
  const onClick = React.useCallback(e => {
    onRowSelectionChange(!isRowSelected, e.nativeEvent.shiftKey, isCtrlDown(e));
  }, [isRowSelected, onRowSelectionChange]);
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    onClick: onClick,
    className: `${rowIndexCellClassName$1} ${isRowSelected ? selectedClassName : ''}`,
    children: rowIdx + 1
  });
};

var css_248z$a = ".s49g3v8.rdg-cell.rdg-cell-frozen{background-color:var(--header-background-color);color:var(--color);padding:0}.s49g3v8.rdg-cell.rdg-cell-frozen:hover{color:var(--color)!important}.rgvub85.rdg-cell.s49g3v8{background-color:var(--row-hover-background-color)}";
styleInject(css_248z$a);

const SELECT_COLUMN_KEY = 'select-row';
const selectCellClassName$1 = "s49g3v8";
const rowCellSelectClassName = "rgvub85";
const SelectColumn = {
  key: SELECT_COLUMN_KEY,
  name: '',
  width: 70,
  resizable: false,
  sortable: false,
  clickable: false,
  frozen: true,
  cellClass: (row, isRowCellSelected) => {
    return clsx(selectCellClassName$1, isRowCellSelected && rowCellSelectClassName);
  },
  headerRenderer(props) {
    return /*#__PURE__*/jsxRuntime.jsx("div", {
      style: {
        width: '100%',
        height: '100%'
      }
    });
  },
  formatter: RowIndexCellFormatter
};

var css_248z$9 = ".thwclf{-webkit-appearance:none;-moz-appearance:none;-ms-appearance:none;appearance:none;background-color:var(--background-color);border:2px solid #ccc;box-sizing:border-box;color:var(--color);font-family:inherit;font-size:var(--font-size);height:100%;padding:0 6px;vertical-align:top;width:100%}.thwclf:focus{border-color:var(--selection-color);outline:none}.thwclf::-webkit-input-placeholder{color:#999;opacity:1}.thwclf::-moz-placeholder{color:#999;opacity:1}.thwclf:-ms-input-placeholder{color:#999;opacity:1}.thwclf::placeholder{color:#999;opacity:1}";
styleInject(css_248z$9);

const textEditor$1 = "thwclf";
const textEditorClassname$1 = `rdg-text-editor ${textEditor$1}`;
function ReadOnlyEditor({
  row,
  column,
  onClose
}) {
  return /*#__PURE__*/jsxRuntime.jsx("input", {
    readOnly: true,
    className: textEditorClassname$1,
    value: (row == null ? void 0 : row[column.key]) || '',
    onBlur: () => onClose(true)
  });
}

function useCalculatedColumns({
  rawColumns,
  columnWidths,
  viewportWidth,
  scrollLeft,
  defaultColumnOptions,
  rawGroupBy,
  enableVirtualization,
  rowsCount,
  readonly
}) {
  var _defaultColumnOptions, _defaultColumnOptions2, _defaultColumnOptions3, _defaultColumnOptions4;
  const minColumnWidth = (_defaultColumnOptions = defaultColumnOptions == null ? void 0 : defaultColumnOptions.minWidth) != null ? _defaultColumnOptions : 80;
  const defaultFormatter = (_defaultColumnOptions2 = defaultColumnOptions == null ? void 0 : defaultColumnOptions.formatter) != null ? _defaultColumnOptions2 : ValueFormatter;
  const defaultSortable = (_defaultColumnOptions3 = defaultColumnOptions == null ? void 0 : defaultColumnOptions.sortable) != null ? _defaultColumnOptions3 : true;
  const defaultResizable = (_defaultColumnOptions4 = defaultColumnOptions == null ? void 0 : defaultColumnOptions.resizable) != null ? _defaultColumnOptions4 : false;
  const selectColumnWidth = Math.floor(Math.floor(Math.log(rowsCount || 1) / Math.log(10)) * 10 + 35);
  const {
    columns,
    lastFrozenColumnIndex,
    groupBy
  } = React.useMemo(() => {
    const groupBy = [];
    let lastFrozenColumnIndex = -1;
    const columns = rawColumns.map(rawColumn => {
      var _rawGroupBy$includes, _rawColumn$sortable, _rawColumn$resizable, _rawColumn$clickable, _rawColumn$formatter;
      const rowGroup = (_rawGroupBy$includes = rawGroupBy == null ? void 0 : rawGroupBy.includes(rawColumn.key)) != null ? _rawGroupBy$includes : false;
      const frozen = rowGroup || rawColumn.frozen || false;
      const column = {
        ...rawColumn,
        idx: 0,
        frozen,
        isLastFrozenColumn: false,
        rowGroup,
        sortable: (_rawColumn$sortable = rawColumn.sortable) != null ? _rawColumn$sortable : defaultSortable,
        resizable: (_rawColumn$resizable = rawColumn.resizable) != null ? _rawColumn$resizable : defaultResizable,
        clickable: (_rawColumn$clickable = rawColumn.clickable) != null ? _rawColumn$clickable : true,
        formatter: (_rawColumn$formatter = rawColumn.formatter) != null ? _rawColumn$formatter : defaultFormatter,
        editor: readonly ? ReadOnlyEditor : rawColumn.editor
      };
      if (rawColumn.key === SELECT_COLUMN_KEY) {
        column.width = selectColumnWidth;
      }
      if (rowGroup) {
        var _column$groupFormatte;
        (_column$groupFormatte = column.groupFormatter) != null ? _column$groupFormatte : column.groupFormatter = ToggleGroupFormatter;
      }
      if (frozen) {
        lastFrozenColumnIndex++;
      }
      return column;
    });
    columns.sort(({
      key: aKey,
      frozen: frozenA
    }, {
      key: bKey,
      frozen: frozenB
    }) => {
      if (aKey === SELECT_COLUMN_KEY) return -1;
      if (bKey === SELECT_COLUMN_KEY) return 1;
      if (rawGroupBy != null && rawGroupBy.includes(aKey)) {
        if (rawGroupBy.includes(bKey)) {
          return rawGroupBy.indexOf(aKey) - rawGroupBy.indexOf(bKey);
        }
        return -1;
      }
      if (rawGroupBy != null && rawGroupBy.includes(bKey)) return 1;
      if (frozenA) {
        if (frozenB) return 0;
        return -1;
      }
      if (frozenB) return 1;
      return 0;
    });
    columns.forEach((column, idx) => {
      column.idx = idx;
    });
    if (lastFrozenColumnIndex !== -1) {
      columns[lastFrozenColumnIndex].isLastFrozenColumn = true;
    }
    return {
      columns,
      lastFrozenColumnIndex,
      groupBy
    };
  }, [rawColumns, defaultFormatter, defaultResizable, defaultSortable, rawGroupBy, rowsCount, readonly]);
  const {
    layoutCssVars,
    totalColumnWidth,
    totalFrozenColumnWidth,
    columnMetrics
  } = React.useMemo(() => {
    const columnMetrics = new Map();
    let left = 0;
    let totalColumnWidth = 0;
    let totalFrozenColumnWidth = 0;
    let templateColumns = '';
    let allocatedWidth = 0;
    let unassignedColumnsCount = 0;
    for (const column of columns) {
      let width = getSpecifiedWidth(column, columnWidths, viewportWidth);
      if (width === undefined) {
        unassignedColumnsCount++;
      } else {
        width = clampColumnWidth(width, column, minColumnWidth);
        allocatedWidth += width;
        columnMetrics.set(column, {
          width,
          left: 0
        });
      }
    }
    const unallocatedWidth = viewportWidth - allocatedWidth - 1;
    const floorWidth = Math.floor(unallocatedWidth / unassignedColumnsCount);
    const lastValue = Math.floor(unallocatedWidth - floorWidth * (unassignedColumnsCount - 1));
    let unallocatedColumnWidth = [];
    if (unassignedColumnsCount > 0) {
      unallocatedColumnWidth = new Array(unassignedColumnsCount - 1).fill(floorWidth);
      unallocatedColumnWidth.push(lastValue);
    }
    for (const column of columns) {
      let width;
      if (columnMetrics.has(column)) {
        const columnMetric = columnMetrics.get(column);
        columnMetric.left = left;
        ({
          width
        } = columnMetric);
      } else {
        width = clampColumnWidth(unallocatedColumnWidth.pop(), column, minColumnWidth);
        columnMetrics.set(column, {
          width,
          left
        });
      }
      totalColumnWidth += width;
      left += width;
      templateColumns += `${width}px `;
    }
    if (lastFrozenColumnIndex !== -1) {
      const columnMetric = columnMetrics.get(columns[lastFrozenColumnIndex]);
      totalFrozenColumnWidth = columnMetric.left + columnMetric.width;
    }
    const layoutCssVars = {
      '--template-columns': templateColumns
    };
    for (let i = 0; i <= lastFrozenColumnIndex; i++) {
      const column = columns[i];
      layoutCssVars[`--frozen-left-${column.key}`] = `${columnMetrics.get(column).left}px`;
    }
    return {
      layoutCssVars,
      totalColumnWidth,
      totalFrozenColumnWidth,
      columnMetrics
    };
  }, [columnWidths, columns, viewportWidth, minColumnWidth, lastFrozenColumnIndex]);
  const [colOverscanStartIdx, colOverscanEndIdx, colVisibleStartIdx, colVisibleEndIdx] = React.useMemo(() => {
    if (!enableVirtualization) {
      return [0, columns.length - 1];
    }
    const viewportLeft = scrollLeft + totalFrozenColumnWidth;
    const viewportRight = scrollLeft + viewportWidth;
    const lastColIdx = columns.length - 1;
    const firstUnfrozenColumnIdx = Math.min(lastFrozenColumnIndex + 1, lastColIdx);
    if (viewportLeft >= viewportRight) {
      return [firstUnfrozenColumnIdx, firstUnfrozenColumnIdx];
    }
    let colVisibleStartIdx = firstUnfrozenColumnIdx;
    while (colVisibleStartIdx < lastColIdx) {
      const {
        left,
        width
      } = columnMetrics.get(columns[colVisibleStartIdx]);
      if (left + width > viewportLeft) {
        break;
      }
      colVisibleStartIdx++;
    }
    let colVisibleEndIdx = colVisibleStartIdx;
    while (colVisibleEndIdx < lastColIdx) {
      const {
        left,
        width
      } = columnMetrics.get(columns[colVisibleEndIdx]);
      if (left + width >= viewportRight) {
        break;
      }
      colVisibleEndIdx++;
    }
    const colOverscanStartIdx = Math.max(firstUnfrozenColumnIdx, colVisibleStartIdx - 10);
    const colOverscanEndIdx = Math.min(lastColIdx, colVisibleEndIdx + 10);
    return [colOverscanStartIdx, colOverscanEndIdx, colVisibleStartIdx, colVisibleEndIdx];
  }, [columnMetrics, columns, lastFrozenColumnIndex, scrollLeft, totalFrozenColumnWidth, viewportWidth, enableVirtualization]);
  return {
    columns,
    colOverscanStartIdx,
    colOverscanEndIdx,
    layoutCssVars,
    columnMetrics,
    totalColumnWidth,
    lastFrozenColumnIndex,
    totalFrozenColumnWidth,
    groupBy,
    colVisibleStartIdx,
    colVisibleEndIdx
  };
}
function getSpecifiedWidth({
  key,
  width
}, columnWidths, viewportWidth) {
  if (columnWidths.has(key)) {
    return columnWidths.get(key);
  }
  if (typeof width === 'number') {
    return width;
  }
  if (typeof width === 'string' && /^\d+%$/.test(width)) {
    return Math.floor(viewportWidth * parseInt(width, 10) / 100);
  }
  return undefined;
}
function clampColumnWidth(width, {
  minWidth,
  maxWidth,
  key
}, minColumnWidth) {
  if (key === SELECT_COLUMN_KEY) {
    return width;
  }
  width = Math.max(width, minWidth != null ? minWidth : minColumnWidth);
  if (typeof maxWidth === 'number') {
    return Math.min(width, maxWidth);
  }
  return width;
}

function useClickOutside(onClick) {
  const frameRequestRef = React.useRef();
  function cancelAnimationFrameRequest() {
    if (typeof frameRequestRef.current === 'number') {
      cancelAnimationFrame(frameRequestRef.current);
      frameRequestRef.current = undefined;
    }
  }
  const onClickRef = React.useRef(() => {
    throw new Error('Cannot call an event handler while rendering.');
  });
  React.useEffect(() => {
    onClickRef.current = onClick;
  });
  React.useEffect(() => {
    function onOutsideClick() {
      frameRequestRef.current = undefined;
      onClickRef.current();
    }
    function onWindowCaptureClick() {
      cancelAnimationFrameRequest();
      frameRequestRef.current = requestAnimationFrame(onOutsideClick);
    }
    window.addEventListener('click', onWindowCaptureClick, {
      capture: true
    });
    return () => {
      window.removeEventListener('click', onWindowCaptureClick, {
        capture: true
      });
      cancelAnimationFrameRequest();
    };
  }, []);
  return cancelAnimationFrameRequest;
}

const ResizeObserver = window.ResizeObserver || resizeObserver.ResizeObserver;
function useGridDimensions() {
  const gridRef = React.useRef(null);
  const [gridWidth, setGridWidth] = React.useState(1);
  const [gridHeight, setGridHeight] = React.useState(1);
  React.useLayoutEffect(() => {
    if (ResizeObserver == null) return;
    const resizeObserver = new ResizeObserver(() => {
      const {
        clientWidth,
        clientHeight
      } = gridRef.current;
      setGridWidth(clientWidth);
      setGridHeight(clientHeight);
    });
    resizeObserver.observe(gridRef.current);
    return () => {
      resizeObserver.disconnect();
    };
  }, []);
  return [gridRef, gridWidth, gridHeight];
}

function useViewportColumns({
  columns,
  colOverscanStartIdx,
  colOverscanEndIdx
}) {
  const startIdx = colOverscanStartIdx;
  return React.useMemo(() => {
    const viewportColumns = [];
    for (let colIdx = 0; colIdx <= colOverscanEndIdx; colIdx++) {
      const column = columns[colIdx];
      if (colIdx < startIdx && !column.frozen) continue;
      viewportColumns.push(column);
    }
    return viewportColumns;
  }, [startIdx, colOverscanEndIdx, columns]);
}

const RENDER_BACTCH_SIZE = 8;
function useViewportRows({
  rawRows,
  rawColumns,
  rowHeight,
  clientHeight,
  scrollTop,
  enableVirtualization,
  sortInfo,
  rowFilters,
  searchKey
}) {
  const rowsCount = rawRows.length;
  const filterRows = React.useCallback(rawRows => {
    const filterColumnKeys = Object.keys(rowFilters).filter(columnKey => {
      var _rowFilters$columnKey;
      return (_rowFilters$columnKey = rowFilters[columnKey]) == null ? void 0 : _rowFilters$columnKey.size;
    });
    if (!filterColumnKeys.length && !searchKey) return rawRows;
    return rawRows.filter(row => {
      let isPass = true;
      if (searchKey) {
        let hit = false;
        for (const columnName of Object.keys(row)) {
          const columnValue = row[columnName] || '';
          if (lodash.isString(columnValue) && columnValue.toLowerCase().indexOf(searchKey == null ? void 0 : searchKey.toLowerCase()) > -1) {
            hit = true;
            break;
          }
        }
        if (!hit) {
          return false;
        }
      }
      for (const columnKey of filterColumnKeys) {
        var _rowFilters$columnKey2;
        let cellValue = row[columnKey];
        if (cellValue === null) {
          cellValue = FILTER_NULL_KEY;
        } else if (typeof cellValue === 'string' && !cellValue.trim()) {
          cellValue = FILTER_EMPTY_KEY;
        }
        if (!((_rowFilters$columnKey2 = rowFilters[columnKey]) != null && _rowFilters$columnKey2.has(cellValue))) {
          isPass = false;
          break;
        }
      }
      return isPass;
    });
  }, [rowFilters, searchKey, rawColumns]);
  const sortRows = React.useCallback(sortedRawRows => {
    if (sortInfo.columnKey && Array.isArray(sortedRawRows) && sortInfo.direction !== "NONE") {
      var _column$dataType;
      const columnKey = sortInfo.columnKey;
      const column = rawColumns == null ? void 0 : rawColumns.find(c => c.key === columnKey);
      const columnType = (_column$dataType = column == null ? void 0 : column.dataType) != null ? _column$dataType : "string";
      sortedRawRows = lodash.sortBy(sortedRawRows, row => {
        const value = row[columnKey];
        if (columnType === "number") {
          return lodash.toNumber(value);
        }
        return value;
      });
      if (sortInfo.direction === "DESC") {
        sortedRawRows = lodash.reverse(sortedRawRows);
      }
    }
    return sortedRawRows;
  }, [sortInfo]);
  const rows = React.useMemo(() => {
    return sortRows(filterRows(rawRows));
  }, [rawRows, searchKey, sortInfo, rowFilters]);
  if (!enableVirtualization) {
    return {
      rowOverscanStartIdx: 0,
      rowOverscanEndIdx: rows.length - 1,
      rows,
      rowsCount
    };
  }
  const overscanThreshold = 10;
  const rowVisibleStartIdx = Math.floor(scrollTop / rowHeight);
  const rowVisibleEndIdx = Math.min(rows.length - 1, Math.floor((scrollTop + clientHeight) / rowHeight));
  const rowOverscanStartIdx = Math.max(0, Math.floor((rowVisibleStartIdx - overscanThreshold) / RENDER_BACTCH_SIZE) * RENDER_BACTCH_SIZE);
  const rowOverscanEndIdx = Math.min(rows.length - 1, Math.ceil((rowVisibleEndIdx + overscanThreshold) / RENDER_BACTCH_SIZE) * RENDER_BACTCH_SIZE);
  return {
    rowOverscanStartIdx,
    rowOverscanEndIdx,
    rowVisibleStartIdx,
    rowVisibleEndIdx,
    rows,
    rowsCount
  };
}

function useLatestFunc(fn) {
  const ref = React.useRef(fn);
  React.useEffect(() => {
    ref.current = fn;
  });
  return React.useCallback((...args) => {
    ref.current(...args);
  }, []);
}

function useMouse(ref, isMouseDown) {
  const [isMouseInElement, setIsMouseInElement] = React.useState(false);
  const [mouseLeaveEvent, setMouseLeaveEvent] = React.useState(null);
  React.useEffect(() => {
    function onMouseLeave(e) {
      setIsMouseInElement(false);
      setMouseLeaveEvent(e);
    }
    function onMouseEnter(e) {
      setIsMouseInElement(true);
      setMouseLeaveEvent(null);
    }
    if (ref.current && isMouseDown) {
      ref.current.addEventListener('mouseout', onMouseLeave);
      ref.current.addEventListener('mouseenter', onMouseEnter);
    }
    return () => {
      var _ref$current, _ref$current2;
      (_ref$current = ref.current) == null || _ref$current.removeEventListener('mouseout', onMouseLeave);
      (_ref$current2 = ref.current) == null || _ref$current2.removeEventListener('mouseenter', onMouseEnter);
    };
  }, [ref.current, isMouseDown]);
  return {
    isMouseInElement,
    mouseLeaveEvent
  };
}

var RangeMode;
(function (RangeMode) {
  RangeMode["SELECT"] = "SELECT";
  RangeMode["EDIT"] = "EDIT";
})(RangeMode || (RangeMode = {}));

const INVALID_IDX = -1;
const defaultSelectedRange = Object.freeze({
  rowIdx: INVALID_IDX,
  columnIdx: INVALID_IDX,
  endRowIdx: INVALID_IDX,
  endColumnIdx: INVALID_IDX,
  mode: RangeMode.SELECT
});
function isRangeSelected(range) {
  return range !== defaultSelectedRange;
}
function isCellInRange(columnIdx, rowIdx, range) {
  const beginColumnIdx = Math.min(range.columnIdx, range.endColumnIdx);
  const endColumnIdx = Math.max(range.columnIdx, range.endColumnIdx);
  const beginRowIdx = Math.min(range.rowIdx, range.endRowIdx);
  const endRowIdx = Math.max(range.rowIdx, range.endRowIdx);
  if (inRange(columnIdx, beginColumnIdx, endColumnIdx + 1) && inRange(rowIdx, beginRowIdx, endRowIdx + 1)) return true;
  return false;
}

function useSelection(rows, columns, isCellWithinRange, rowKeyGetter, onSelectChange) {
  const [selectedRange, setSelectedRange] = React.useState(defaultSelectedRange);
  const [selectedColumns, setSelectColumns] = React.useState(new Set());
  const [selectedRows, setSelectedRows] = React.useState(new Set());
  const startIdxRef = React.useRef(0);
  const isSelectedRangeEditable = React.useMemo(() => {
    return isCellWithinRange(selectedRange) && isCellEditable({
      row: rows[selectedRange.rowIdx],
      column: columns[selectedRange.columnIdx]
    });
  }, [selectedRange, isCellWithinRange, rows, columns]);
  const selectRow = React.useCallback(({
    rowIdx,
    isShiftClick,
    isCtrlClick
  }) => {
    var _selectedRows$has;
    const row = rows[rowIdx];
    const rowKey = rowKeyGetter(row);
    const checked = (_selectedRows$has = selectedRows == null ? void 0 : selectedRows.has(rowKey)) != null ? _selectedRows$has : false;
    const nextSelectedRows = new Set(selectedRows);
    if (isCtrlClick) {
      if (!checked) {
        nextSelectedRows.add(rowKey);
      } else {
        nextSelectedRows.delete(rowKey);
      }
    } else if (isShiftClick) {
      const endIdx = rowIdx;
      const minIndex = Math.min(startIdxRef.current, endIdx);
      const maxIndex = Math.max(startIdxRef.current, endIdx);
      nextSelectedRows.clear();
      for (let i = minIndex; i <= maxIndex; i++) {
        nextSelectedRows.add(rowKeyGetter(rows[i]));
      }
    } else {
      nextSelectedRows.clear();
      if (!checked) {
        nextSelectedRows.add(rowKey);
        startIdxRef.current = rowIdx;
      }
    }
    setSelectColumns(new Set());
    setSelectedRows(nextSelectedRows);
    setSelectedRange(defaultSelectedRange);
    onSelectChange == null || onSelectChange([...nextSelectedRows], []);
  }, [rows, rowKeyGetter, selectedRows, startIdxRef, onSelectChange]);
  const selectColumn = React.useCallback(({
    columnIdx,
    isShiftClick,
    isCtrlClick
  }) => {
    var _columns$columnIdx, _selectedColumns$has;
    const key = (_columns$columnIdx = columns[columnIdx]) == null ? void 0 : _columns$columnIdx.key;
    if (!key) {
      return;
    }
    const checked = (_selectedColumns$has = selectedColumns == null ? void 0 : selectedColumns.has(key)) != null ? _selectedColumns$has : false;
    const nextSelectedColumns = new Set(selectedColumns);
    if (isCtrlClick) {
      if (!checked) {
        nextSelectedColumns.add(key);
      } else {
        nextSelectedColumns.delete(key);
      }
    } else if (isShiftClick) {
      const endIdx = columnIdx;
      const minIndex = Math.min(startIdxRef.current, endIdx);
      const maxIndex = Math.max(startIdxRef.current, endIdx);
      nextSelectedColumns.clear();
      for (let i = minIndex; i <= maxIndex; i++) {
        var _columns$i;
        if ((_columns$i = columns[i]) != null && _columns$i.key) {
          nextSelectedColumns.add(columns[i].key);
        }
      }
    } else {
      nextSelectedColumns.clear();
      if (!checked) {
        nextSelectedColumns.add(key);
        startIdxRef.current = columnIdx;
      }
    }
    setSelectColumns(nextSelectedColumns);
    if (columnIdx !== 0) {
      setSelectedRows(new Set());
    }
    setSelectedRange(defaultSelectedRange);
    onSelectChange == null || onSelectChange([], [...nextSelectedColumns]);
  }, [columns, selectedColumns, startIdxRef, onSelectChange]);
  const selectCell = React.useCallback((position, isShiftClick = false, enableEditor = false) => {
    if (!isCellWithinRange(position)) return;
    if (enableEditor && isSelectedRangeEditable) {
      setSelectedRange({
        ...position,
        mode: RangeMode.EDIT,
        key: null
      });
    } else {
      if (isShiftClick) {
        const {
          endColumnIdx,
          endRowIdx
        } = position;
        setSelectedRange({
          ...selectedRange,
          endColumnIdx,
          endRowIdx,
          mode: RangeMode.SELECT
        });
      } else {
        setSelectedRange({
          ...position,
          mode: RangeMode.SELECT
        });
      }
    }
    setSelectColumns(new Set());
    if (![-1, 0].includes(position.columnIdx)) {
      setSelectedRows(new Set());
    }
    if (position.rowIdx < 0) {
      onSelectChange == null || onSelectChange([]);
    } else {
      const {
        rowIdx,
        endRowIdx,
        columnIdx,
        endColumnIdx
      } = position;
      onSelectChange == null || onSelectChange((rows == null ? void 0 : rows.slice(Math.min(rowIdx, endRowIdx), Math.max(rowIdx, endRowIdx) + 1).map(row => rowKeyGetter(row))) || [], columns == null ? void 0 : columns.slice(Math.min(columnIdx, endColumnIdx), Math.max(columnIdx, endColumnIdx) + 1).map(column => column.key));
    }
  }, [isCellWithinRange, selectedRange, rows, isSelectedRangeEditable, onSelectChange]);
  const selectAllRows = React.useCallback(() => {
    if (!(rows != null && rows.length)) {
      return;
    }
    const rowIndexs = rows.map(row => rowKeyGetter(row));
    const columnIndexs = columns.map(column => column.key);
    const newSelectedRows = new Set(rowIndexs);
    const newSelectedColumns = new Set(columnIndexs);
    setSelectedRows(newSelectedRows);
    setSelectColumns(newSelectedColumns);
    setSelectedRange({
      ...defaultSelectedRange,
      columnIdx: 0,
      rowIdx: 0,
      endColumnIdx: columns.length - 1,
      endRowIdx: rows.length - 1
    });
    onSelectChange == null || onSelectChange([...newSelectedRows], [...newSelectedColumns]);
  }, [rows, columns]);
  const handleSelect = useLatestFunc(React.useCallback(data => {
    const {
      rowIdx,
      columnIdx,
      isShiftClick = false,
      isCtrlClick = false,
      isUpdateIndex = true,
      enableEditor = false
    } = data;
    if (rowIdx === -1 || columnIdx === -1) {
      if (rowIdx === -1 && columnIdx === -1) {
        selectAllRows();
      } else if (rowIdx === -1) {
        selectColumn({
          columnIdx,
          isShiftClick,
          isCtrlClick
        });
      } else {
        selectRow({
          rowIdx,
          isShiftClick,
          isCtrlClick
        });
      }
    } else {
      const _selectedRange = {
        ...selectedRange,
        endColumnIdx: columnIdx,
        endRowIdx: rowIdx
      };
      if (isUpdateIndex) {
        _selectedRange.columnIdx = columnIdx;
        _selectedRange.rowIdx = rowIdx;
      }
      selectCell(_selectedRange, false, enableEditor);
    }
  }, [selectAllRows, selectColumn, selectRow, selectedRange, selectCell]));
  return {
    selectedRange,
    selectedRows,
    selectedColumns,
    isSelectedRangeEditable,
    handleSelect
  };
}

function usePaste(options) {
  const {
    gridContext,
    patchRows,
    pasteFormatter
  } = options;
  return text => {
    const {
      rows,
      columns,
      rowKeyName,
      rowKeyGetter,
      selectedRows,
      selectedColumns,
      selectedRange
    } = gridContext;
    const columnLength = columns.length - 1;
    const contentStartColIdx = columns.findIndex(col => col.key !== SELECT_COLUMN_KEY);
    const csvArray = parseCSV(text);
    const updatedRows = [];
    const insertedRows = [];
    function produceRow(row, start, end, csvRow) {
      const draftRow = lodash.cloneDeep(row);
      while (start <= end && csvRow.length) {
        let colValue = csvRow.shift();
        const column = columns[start];
        if (isCellEditable({
          row,
          column
        })) {
          draftRow[column.key] = pasteFormatter ? pasteFormatter(row, column, colValue) : colValue;
        }
        start++;
      }
      return draftRow;
    }
    function insertRows(csvArray, rowProducer) {
      if (!csvArray.length) return;
      csvArray.forEach(csvRow => {
        insertedRows.push(rowProducer(csvRow));
      });
    }
    if (selectedRows != null && selectedRows.size) {
      let rowBeginIdx = Math.min(...rows.map((row, idx) => {
        return selectedRows.has(rowKeyGetter(row)) ? idx : Number.MAX_SAFE_INTEGER;
      }));
      let i = rowBeginIdx;
      for (; i < rows.length; i++) {
        const csvRow = csvArray.shift();
        if (!csvRow) break;
        const editedRow = produceRow(rows[i], contentStartColIdx, columnLength, csvRow);
        updatedRows.push(editedRow);
      }
      if (i === rows.length && csvArray.length) {
        insertRows(csvArray, csvRow => produceRow({}, contentStartColIdx, columnLength, csvRow));
      }
    } else if (selectedColumns.size) {
      const columnBeginIdx = columns.findIndex(column => {
        return selectedColumns.has(column.key);
      });
      csvArray.forEach((csvRow, rowIdx) => {
        if (!rows[rowIdx]) return;
        if (columnBeginIdx !== -1) {
          updatedRows.push(produceRow(rows[rowIdx], columnBeginIdx, columns.length - 1, csvRow));
        }
      });
    } else if (isRangeSelected(selectedRange)) {
      const startIdx = Math.min(selectedRange.columnIdx, selectedRange.endColumnIdx);
      let endIdx = Math.max(selectedRange.columnIdx, selectedRange.endColumnIdx);
      let startRowIdx = Math.min(selectedRange.rowIdx, selectedRange.endRowIdx);
      let endRowIdx = Math.max(selectedRange.rowIdx, selectedRange.endRowIdx);
      if (startIdx === endIdx && startRowIdx === endRowIdx) {
        endRowIdx = rows.length - 1;
        endIdx = columns.length - 1;
      }
      while (startRowIdx <= endRowIdx) {
        const draftRow = lodash.cloneDeep(rows[startRowIdx]);
        const csvRow = csvArray.shift();
        if (csvRow) {
          const editedRow = produceRow(draftRow, startIdx, endIdx, csvRow);
          updatedRows.push(editedRow);
        }
        startRowIdx++;
      }
      const isLastRowSelected = startRowIdx === rows.length;
      isLastRowSelected && insertRows(csvArray, csvRow => produceRow({}, startIdx, endIdx, csvRow));
    }
    patchRows({
      modifiedRows: updatedRows,
      newRows: insertedRows == null ? void 0 : insertedRows.map(item => ({
        ...item,
        _created: true,
        [rowKeyName]: generateUniqKey()
      }))
    });
  };
}
const newLine = '\n';
const delimiter = '\t';
function parseCSV(text) {
  const csvArray = [];
  text = text.replace(/\r\n/g, '\n');
  if (text.endsWith('\n')) {
    text = text.substring(0, text.length - 1);
  }
  const lines = text.split(newLine);
  lines.forEach(line => {
    const row = line.split(delimiter);
    csvArray.push(row);
  });
  return csvArray;
}

function useLatest(value) {
  const ref = React.useRef(value);
  ref.current = value;
  return ref;
}

const locales = {
  "zh-cn": {
    "DataGrid.changeTopRowSet.tooMuchFrozen": "冻结行数过多，无法正常预览",
    "DefaultContextMenuRender.copyRow": "复制行",
    "DefaultContextMenuRender.frozenRow": "冻结此行",
    "DefaultContextMenuRender.unFrozenAll": "解除全部冻结行",
    "DefaultContextMenuRender.newRow": "新增一行",
    "DefaultContextMenuRender.deleteRow": "删除",
    "DefaultContextMenuRender.upRow": "向上移动一行",
    "DefaultContextMenuRender.downRow": "向下移动一行",
    "HeaderCell.onDoubleClick.copyName": "复制列名成功",
    "SummaryCell.SelectColumnCell.unFrozen": "解冻",
    "headerCells.SortableHeaderCell.checkAll": "全选",
    "headerCells.SortableHeaderCell.cancelAll": "取消全选",
    "headerCells.SortableHeaderCell.cancel": "取消",
    "headerCells.SortableHeaderCell.ok": "确定",
    "headerCells.SortableHeaderCell.maxLimitText": "最大展示 200 条，超出部分已省略"
  },
  "en-us": {
    "DataGrid.changeTopRowSet.tooMuchFrozen": "Too many frozen rows, unable to preview normally",
    "DefaultContextMenuRender.copyRow": "Copy Row",
    "DefaultContextMenuRender.frozenRow": "Freeze this row",
    "DefaultContextMenuRender.unFrozenAll": "Unlock all frozen rows",
    "DefaultContextMenuRender.newRow": "Add row",
    "DefaultContextMenuRender.deleteRow": "Delete",
    "DefaultContextMenuRender.upRow": "Move up one line",
    "DefaultContextMenuRender.downRow": "Move down one line",
    "HeaderCell.onDoubleClick.copyName": "The column name was copied successfully",
    "SummaryCell.SelectColumnCell.unFrozen": "Unfreeze",
    "headerCells.SortableHeaderCell.checkAll": "Select All",
    "headerCells.SortableHeaderCell.cancelAll": "Cancel All Selection",
    "headerCells.SortableHeaderCell.cancel": "Cancel",
    "headerCells.SortableHeaderCell.ok": "OK",
    "headerCells.SortableHeaderCell.maxLimitText": "Max display: 200 items"
  },
  "zh-tw": {
    "DataGrid.changeTopRowSet.tooMuchFrozen": "凍結行數過多，無法正常預覽",
    "DefaultContextMenuRender.copyRow": "複製行",
    "DefaultContextMenuRender.frozenRow": "凍結此行",
    "DefaultContextMenuRender.unFrozenAll": "解除全部凍結行",
    "DefaultContextMenuRender.newRow": "新增一行",
    "DefaultContextMenuRender.deleteRow": "刪除",
    "DefaultContextMenuRender.upRow": "Move up one line",
    "DefaultContextMenuRender.downRow": "Move down one line",
    "HeaderCell.onDoubleClick.copyName": "列名複製成功",
    "SummaryCell.SelectColumnCell.unFrozen": "解凍",
    "headerCells.SortableHeaderCell.checkAll": "全選",
    "headerCells.SortableHeaderCell.cancelAll": "取消所有選擇",
    "headerCells.SortableHeaderCell.cancel": "取消",
    "headerCells.SortableHeaderCell.ok": "確定",
    "headerCells.SortableHeaderCell.maxLimitText": "最大展示 200 條，超出部分已省略"
  }
};
function getLocale() {
  var _window$localStorage$, _browserLang;
  let browserLang;
  const isNavigatorLanguageValid = typeof navigator !== 'undefined' && typeof navigator.language === 'string';
  browserLang = isNavigatorLanguageValid ? navigator.language.split('-').join('-') : '';
  return ((_window$localStorage$ = window.localStorage.getItem('umi_locale')) == null || _window$localStorage$.toLowerCase == null ? void 0 : _window$localStorage$.toLowerCase()) || ((_browserLang = browserLang) == null ? void 0 : _browserLang.toLowerCase()) || 'en-us';
}
function formatMessage(key) {
  const locale = getLocale();
  const localText = locales[locale] || locales["en-us"];
  return localText == null ? void 0 : localText[key];
}

var css_248z$8 = ".h1j9yp5q{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex}.h1e6at1o{-webkit-box-flex:1;-ms-flex-positive:1;-webkit-flex-grow:1;flex-grow:1;overflow:hidden;overflow:clip;text-overflow:ellipsis}.d1t8izji{font-size:14px;margin-right:-8px;-webkit-transform:rotate(-90deg);-moz-transform:rotate(-90deg);-ms-transform:rotate(-90deg);transform:rotate(-90deg)}.u17imids{font-size:14px;-webkit-transform:rotate(90deg);-moz-transform:rotate(90deg);-ms-transform:rotate(90deg);transform:rotate(90deg)}.f12nnqqz{color:var(--text-color-primary);cursor:pointer}.f12nnqqz:hover{color:#1890ff}";
styleInject(css_248z$8);

const headerSortCell = "h1j9yp5q";
const headerSortCellClassname = `rdg-header-sort-cell ${headerSortCell}`;
const headerSortName = "h1e6at1o";
const downClassname = "d1t8izji";
const upClassname = "u17imids";
const filterBtnClassName = "f12nnqqz";
const {
  Text
} = antd.Typography;
const headerSortNameClassname = `rdg-header-sort-name ${headerSortName}`;
function SortIcon({
  direction
}) {
  return /*#__PURE__*/jsxRuntime.jsxs("span", {
    children: [/*#__PURE__*/jsxRuntime.jsx(icons.SwapLeftOutlined, {
      className: downClassname,
      style: direction === 'DESC' ? {
        color: '#1890ff'
      } : undefined
    }), /*#__PURE__*/jsxRuntime.jsx(icons.SwapLeftOutlined, {
      className: upClassname,
      style: direction === 'ASC' ? {
        color: '#1890ff'
      } : undefined
    })]
  });
}
function SortableHeaderCell({
  column,
  onSort,
  sortInfo: {
    columnKey: sortColumn,
    direction: sortDirection
  },
  enableSortRow,
  cellFilters,
  checkedFilters,
  onCellFiltersChange,
  children
}) {
  sortDirection = sortColumn === column.key && sortDirection || 'NONE';
  const [cellFilterVisible, setCellFilterVisible] = React.useState(false);
  const _onCellFiltersChange = React.useCallback((columnKey, newFilters) => {
    onCellFiltersChange(columnKey, newFilters);
    setCellFilterVisible(false);
  }, [onCellFiltersChange]);
  function onClick(e) {
    e.stopPropagation();
    if (!onSort) return;
    const {
      sortDescendingFirst
    } = column;
    let direction;
    switch (sortDirection) {
      case 'ASC':
        direction = sortDescendingFirst ? 'NONE' : 'DESC';
        break;
      case 'DESC':
        direction = sortDescendingFirst ? 'ASC' : 'NONE';
        break;
      default:
        direction = sortDescendingFirst ? 'DESC' : 'ASC';
        break;
    }
    onSort(column.key, direction);
  }
  return /*#__PURE__*/jsxRuntime.jsxs("span", {
    className: headerSortCellClassname,
    children: [/*#__PURE__*/jsxRuntime.jsx("span", {
      className: headerSortNameClassname,
      children: children
    }), /*#__PURE__*/jsxRuntime.jsxs(antd.Space, {
      style: {
        color: 'rgba(0,0,0,0.45)'
      },
      size: 3,
      children: [!!cellFilters && /*#__PURE__*/jsxRuntime.jsx(antd.Popover, {
        destroyTooltipOnHide: true,
        trigger: "click",
        placement: "bottom",
        open: cellFilterVisible,
        onOpenChange: v => {
          setCellFilterVisible(v);
        },
        arrow: false,
        content: /*#__PURE__*/jsxRuntime.jsx(FilterContent, {
          cellFilters: cellFilters,
          checkedFilters: checkedFilters,
          columnKey: column.key,
          onCellFiltersChange: _onCellFiltersChange
        }),
        children: /*#__PURE__*/jsxRuntime.jsx("span", {
          onClick: e => {
            e.stopPropagation();
          },
          className: filterBtnClassName,
          children: /*#__PURE__*/jsxRuntime.jsx(icons.FilterOutlined, {
            style: checkedFilters != null && checkedFilters.size ? {
              color: '#1890ff'
            } : undefined
          })
        })
      }), !!(enableSortRow && column.sortable) && /*#__PURE__*/jsxRuntime.jsx("span", {
        style: {
          cursor: 'pointer',
          color: 'var(--text-color-primary)'
        },
        onClick: onClick,
        children: /*#__PURE__*/jsxRuntime.jsx(SortIcon, {
          direction: sortDirection
        })
      })]
    })]
  });
}
const SortableHeaderCell$1 = /*#__PURE__*/React.memo(SortableHeaderCell);
const MAX_FILTER_COUNT = 200;
function FilterContent({
  cellFilters,
  checkedFilters,
  onCellFiltersChange,
  columnKey
}) {
  const [searchValue, setSearchValue] = React.useState();
  const [checkedValue, setCheckedValue] = React.useState(Array.from(checkedFilters != null ? checkedFilters : []));
  const [options, isOutLimit] = React.useMemo(() => {
    let isOutLimit = false;
    let _options = [...cellFilters].filter(v => {
      var _v;
      if (typeof v === 'number') {
        v = v + '';
      }
      return ((_v = v) == null || _v.toLowerCase == null ? void 0 : _v.toLowerCase().indexOf((searchValue == null ? void 0 : searchValue.toLowerCase()) || '')) > -1;
    });
    if (_options.length > MAX_FILTER_COUNT) {
      _options = _options.slice(0, MAX_FILTER_COUNT);
      isOutLimit = true;
    }
    return [_options, isOutLimit];
  }, [cellFilters, searchValue]);
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    onClick: e => {
      e.stopPropagation();
    },
    children: /*#__PURE__*/jsxRuntime.jsxs(antd.Space, {
      direction: "vertical",
      children: [/*#__PURE__*/jsxRuntime.jsx(antd.Input.Search, {
        autoFocus: true,
        onClick: function (e) {
          e.currentTarget.focus();
        },
        value: searchValue,
        onChange: e => {
          setSearchValue(e.target.value);
        }
      }), isOutLimit ? /*#__PURE__*/jsxRuntime.jsx(Text, {
        type: "secondary",
        children: formatMessage("headerCells.SortableHeaderCell.maxLimitText")
      }) : null, /*#__PURE__*/jsxRuntime.jsx("div", {
        style: {
          maxHeight: 300,
          overflow: 'auto',
          border: '1px solid #ddd',
          padding: 12,
          width: 300
        },
        children: /*#__PURE__*/jsxRuntime.jsx(antd.Checkbox.Group, {
          value: checkedValue,
          onChange: v => {
            setCheckedValue(v);
          },
          children: /*#__PURE__*/jsxRuntime.jsxs(antd.Space, {
            direction: "vertical",
            children: [options.includes('null') && /*#__PURE__*/jsxRuntime.jsx(antd.Checkbox, {
              value: 'null',
              children: "null"
            }, 'null'), options.map(option => {
              if (option === 'null') {
                return null;
              }
              return /*#__PURE__*/jsxRuntime.jsx(antd.Checkbox, {
                value: option,
                children: option
              }, option);
            }).filter(Boolean)]
          })
        })
      }), /*#__PURE__*/jsxRuntime.jsxs("div", {
        style: {
          display: 'flex',
          justifyContent: 'space-between'
        },
        children: [/*#__PURE__*/jsxRuntime.jsxs(antd.Space, {
          children: [/*#__PURE__*/jsxRuntime.jsx("a", {
            onClick: () => {
              setCheckedValue(options);
            },
            children: formatMessage("headerCells.SortableHeaderCell.checkAll")
          }), /*#__PURE__*/jsxRuntime.jsx("a", {
            onClick: () => {
              setCheckedValue([]);
            },
            children: formatMessage("headerCells.SortableHeaderCell.cancelAll")
          })]
        }), /*#__PURE__*/jsxRuntime.jsxs(antd.Space, {
          children: [/*#__PURE__*/jsxRuntime.jsx(antd.Button, {
            onClick: () => {
              onCellFiltersChange(columnKey, checkedFilters);
            },
            children: formatMessage("headerCells.SortableHeaderCell.cancel")
          }), /*#__PURE__*/jsxRuntime.jsx(antd.Button, {
            onClick: () => {
              onCellFiltersChange(columnKey, new Set(checkedValue));
            },
            type: "primary",
            children: formatMessage("headerCells.SortableHeaderCell.ok")
          })]
        })]
      })]
    })
  });
}

function useCombinedRefs(...refs) {
  return React.useCallback(handle => {
    for (const ref of refs) {
      if (typeof ref === 'function') {
        ref(handle);
      } else if (ref !== null) {
        ref.current = handle;
      }
    }
  }, refs);
}

var css_248z$7 = ".c6l2wv1:after{bottom:0;content:\"\";cursor:col-resize;position:absolute;right:0;top:0;width:10px}.h1kqdw7y{background-color:var(--header-background-color)}.c1y6ywlx{background-color:var(--row-hover-background-color)}.c1bezg5o:before{background:var(--row-selected-background-color);content:\"\";height:100%;left:0;position:absolute;top:0;width:100%;width:2px;z-index:1}";
styleInject(css_248z$7);

const cellResizable = "c6l2wv1";
const headerCellClass = "h1kqdw7y";
const columnSelectClassname = "c1y6ywlx";
const columnIsDrop = "c1bezg5o";
const cellResizableClassname = `rdg-cell-resizable ${cellResizable}`;
const DRAG_KEY$1 = 'rdg-header-cell';
function HeaderCell({
  column,
  columnIdx,
  onResize,
  allRowsSelected,
  isCellSelected,
  cellFilters,
  filters,
  onGridSelect,
  onCellFiltersChange,
  onColumnReorder,
  sortInfo,
  enableSortRow,
  onSort
}) {
  const cellRef = React.useRef(null);
  const onColumnClick = React.useCallback(function (e) {
    const isFirstColumn = columnIdx === 0;
    onGridSelect({
      rowIdx: -1,
      columnIdx: isFirstColumn ? -1 : columnIdx,
      isShiftClick: e.shiftKey,
      isCtrlClick: isCtrlDown(e)
    });
  }, [column, onGridSelect]);
  const onDoubleClick = React.useCallback(function (e) {
    var _cellRef$current;
    if (!((_cellRef$current = cellRef.current) != null && _cellRef$current.contains(e.target)) || column.key === SELECT_COLUMN_KEY) {
      return;
    }
    const name = lodash.toString(column.name);
    copyToClipboard(name);
    antd.message.success(formatMessage("HeaderCell.onDoubleClick.copyName"));
  }, [column, cellRef]);
  const drag = reactDnd.useDrag({
    type: DRAG_KEY$1,
    item: {
      columnKey: column.key,
      type: DRAG_KEY$1
    },
    collect: monitor => ({
      isDragging: monitor.isDragging()
    })
  });
  const drop = reactDnd.useDrop({
    accept: DRAG_KEY$1,
    drop({
      columnKey,
      type
    }) {
      if (type === DRAG_KEY$1) {
        onColumnReorder == null || onColumnReorder(columnKey, column.key);
      }
    },
    collect: monitor => ({
      isOver: monitor.isOver(),
      canDrop: monitor.canDrop()
    })
  });
  function onPointerDown(event) {
    if (event.pointerType === 'mouse' && event.buttons !== 1) {
      return;
    }
    const {
      currentTarget,
      pointerId
    } = event;
    const {
      right
    } = currentTarget.getBoundingClientRect();
    const offset = right - event.clientX;
    if (offset > 11) {
      return;
    }
    function onPointerMove(event) {
      if (event.pointerId !== pointerId) return;
      if (event.pointerType === 'mouse' && event.buttons !== 1) {
        onPointerUp(event);
        return;
      }
      const width = event.clientX + offset - currentTarget.getBoundingClientRect().left;
      if (width > 0) {
        onResize(column, width);
      }
    }
    function onPointerUp(event) {
      if (event.pointerId !== pointerId) return;
      window.removeEventListener('pointermove', onPointerMove);
      window.removeEventListener('pointerup', onPointerUp);
    }
    event.preventDefault();
    window.addEventListener('pointermove', onPointerMove);
    window.addEventListener('pointerup', onPointerUp);
  }
  function getCell() {
    if (column.headerRenderer) {
      return /*#__PURE__*/jsxRuntime.jsx(column.headerRenderer, {
        column: column,
        sortInfo: sortInfo,
        onSort: onSort,
        allRowsSelected: allRowsSelected
      });
    }
    if (enableSortRow || column.sortable || cellFilters) {
      return /*#__PURE__*/jsxRuntime.jsx(SortableHeaderCell$1, {
        column: column,
        onSort: onSort,
        sortInfo: sortInfo,
        enableSortRow: enableSortRow,
        cellFilters: cellFilters,
        checkedFilters: filters,
        onCellFiltersChange: onCellFiltersChange,
        children: column.name
      });
    }
    return column.name;
  }
  const className = getCellClassname(column, column.headerCellClass, headerCellClass, column.resizable && cellResizableClassname, isCellSelected && columnSelectClassname, drop[0].isOver && columnIsDrop);
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    role: "columnheader",
    "aria-colindex": column.idx + 1,
    "aria-rowindex": -1,
    className: className,
    style: getCellStyle(column),
    onPointerDown: column.resizable ? onPointerDown : undefined,
    onClick: onColumnClick,
    onDoubleClick: onDoubleClick,
    ref: onColumnReorder ? useCombinedRefs(drag[1], column.key !== SELECT_COLUMN_KEY ? drop[1] : null, cellRef) : cellRef,
    children: getCell()
  });
}

function HeaderRow({
  columns,
  onColumnReorder,
  allRowsSelected,
  selectedRange,
  selectedColumns,
  onGridSelect,
  onColumnResize,
  sortInfo,
  enableSortRow,
  rowFilterOptions,
  rowFilters,
  onFiltersChange,
  onSort,
  lastFrozenColumnIndex
}) {
  const cells = [];
  const onCellFiltersChange = React.useCallback((key, newFilters) => {
    onFiltersChange == null || onFiltersChange({
      ...rowFilters,
      [key]: newFilters
    });
  }, [onFiltersChange, rowFilters]);
  for (let index = 0; index < columns.length; index++) {
    const column = columns[index];
    const [minIdx, maxIdx] = [selectedRange.columnIdx, selectedRange.endColumnIdx].sort((a, b) => a - b);
    const isColumnCellSelect = maxIdx >= column.idx && column.idx >= minIdx;
    const isCellSelected = isColumnCellSelect || selectedColumns.has(column.key);
    cells.push( /*#__PURE__*/jsxRuntime.jsx(HeaderCell, {
      column: column,
      columnIdx: column.idx,
      filters: rowFilters == null ? void 0 : rowFilters[column.key],
      onCellFiltersChange: onCellFiltersChange,
      isCellSelected: isCellSelected,
      onResize: onColumnResize,
      allRowsSelected: allRowsSelected,
      onSort: onSort,
      sortInfo: sortInfo,
      enableSortRow: enableSortRow,
      cellFilters: rowFilterOptions == null ? void 0 : rowFilterOptions[column.key],
      onGridSelect: onGridSelect,
      onColumnReorder: onColumnReorder
    }, column.key));
  }
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    role: "row",
    "aria-rowindex": 1,
    className: headerRowClassname,
    children: cells
  });
}
const HeaderRow$1 = /*#__PURE__*/React.memo(HeaderRow);

var css_248z$6 = ".c6ra8a3,.cq910m0{background-color:#ccf}.cq910m0.c6ra8a3{background-color:#99f}.cjdi1s6{background-color:var(--selection-color);bottom:0;cursor:move;height:8px;position:absolute;right:0;width:8px}.cjdi1s6:hover{background-color:var(--background-color);border:2px solid var(--selection-color);height:16px;width:16px}.c1hmg4s1:before{background:var(--row-selected-background-color);content:\"\";height:2px;position:absolute;top:0;width:100%;z-index:1}.c1j6xs86{contain:none;overflow:visible}.c1lt6idb.rdg-cell{background-color:var(--table-edit-color)}";
styleInject(css_248z$6);

const cellDraggedOver = "cq910m0";
const cellDraggedOverClassname = `rdg-cell-dragged-over ${cellDraggedOver}`;
const cellDragHandle = "cjdi1s6";
const cellDropOverClassname = "c1hmg4s1";
const cellIsRowSelectClassname = "c1j6xs86";
const cellModifiedClassname = "c1lt6idb";
const cellDragHandleClassname = `rdg-cell-drag-handle ${cellDragHandle}`;
function Cell({
  className,
  column,
  columnIdx,
  drop,
  drag,
  isCellSelected,
  isCellFirstSelected,
  isDraggedOver,
  isRowSelected,
  row,
  rowIdx,
  dragHandleProps,
  isRowCellSelected,
  isColumnSelected,
  setMouseDown,
  lazyStore,
  isModified,
  onClick,
  onDoubleClick,
  onContextMenu,
  onRowChange,
  onRowReorder,
  onGridSelect,
  enableRowRecord,
  selectedRange,
  ...props
}, ref) {
  const {
    cellClass
  } = column;
  const cellRef = React.useRef();
  const unionRef = useCombinedRefs(ref, drop[1], drag[1], cellRef);
  const normalRef = useCombinedRefs(cellRef, ref);
  const isSelectColumn = SELECT_COLUMN_KEY === column.key;
  const [innerMouseDownPosition, setInnerMouseDownPosition] = React.useState();
  className = getCellClassname(column, (isCellSelected || isColumnSelected) && cellSelectedClassname, typeof cellClass === 'function' ? cellClass(row, isRowCellSelected) : cellClass, className, isSelectColumn && [drop[0].isOver && cellDropOverClassname, isRowSelected && cellIsRowSelectClassname], isDraggedOver && cellDraggedOverClassname, isModified && cellModifiedClassname);
  React.useEffect(() => {
    function _tmp() {
      if (innerMouseDownPosition) {
        setInnerMouseDownPosition(null);
      }
    }
    window.addEventListener('mouseup', _tmp);
    return () => {
      window.removeEventListener('mouseup', _tmp);
    };
  }, [innerMouseDownPosition]);
  function selectCellWrapper(isShiftClick, enableEditor) {
    onGridSelect({
      rowIdx,
      columnIdx,
      isShiftClick,
      enableEditor
    });
  }
  function handleDoubleClick(event) {
    if (event.currentTarget.contains(event.target)) {
      selectCellWrapper(false, true);
      onDoubleClick == null || onDoubleClick(event);
    }
  }
  function handleRowChange(newRow) {
    onRowChange(newRow);
  }
  function onRowSelectionChange(checked, isShiftClick, isCtrlClick) {
    onGridSelect({
      rowIdx,
      columnIdx: -1,
      isShiftClick,
      isCtrlClick
    });
  }
  function checkIsSelf(event) {
    return event.nativeEvent.target.closest('.ant-menu') === null;
  }
  function handleMouseDown(event) {
    var _event$target;
    const isShiftClick = event.nativeEvent.shiftKey;
    if (isShiftClick) {
      event.preventDefault();
      return;
    }
    if (!((_event$target = event.target) != null && _event$target.closest != null && _event$target.closest('.rdg-cell'))) {
      return;
    }
    if (isSelectColumn || event.button !== 0) {
      return;
    }
    if (!checkIsSelf(event)) {
      return;
    }
    setMouseDown(true);
    setInnerMouseDownPosition({
      clientX: event.clientX,
      clientY: event.clientY,
      isSelected: isCellFirstSelected
    });
    if (column.clickable) {
      onGridSelect({
        rowIdx,
        columnIdx,
        isShiftClick: false,
        isCtrlClick: false
      });
    }
    if (!isCellFirstSelected) {
      selectCellWrapper(isShiftClick, false);
    }
  }
  function handleMouseUp(event) {
    const isShiftClick = event.nativeEvent.shiftKey;
    const {
      clientX,
      clientY,
      button
    } = event;
    if (button !== 0 || isSelectColumn || !innerMouseDownPosition) {
      return;
    }
    if (!checkIsSelf(event)) {
      return;
    }
    if (column.clickable) {
      if (innerMouseDownPosition && innerMouseDownPosition.clientX === clientX && innerMouseDownPosition.clientY === clientY) {
        if (innerMouseDownPosition.isSelected) {
          selectCellWrapper(isShiftClick, true);
        } else {
          var _column$editorOptions;
          selectCellWrapper(isShiftClick, (_column$editorOptions = column.editorOptions) == null ? void 0 : _column$editorOptions.editOnClick);
        }
      }
    }
    onClick == null || onClick(event);
  }
  function handleMouseEnter() {
    if (lazyStore.get('isMouseDown')) {
      onGridSelect({
        rowIdx,
        columnIdx,
        isShiftClick: false,
        isCtrlClick: false,
        isUpdateIndex: false
      });
    }
  }
  const baseCell = /*#__PURE__*/jsxRuntime.jsx("div", {
    role: "gridcell",
    "aria-colindex": column.idx + 1,
    "aria-rowindex": rowIdx,
    "aria-selected": isCellSelected,
    ref: enableRowRecord && isSelectColumn ? unionRef : normalRef,
    title: lodash.toString(row[column.key]) || '',
    className: className,
    style: getCellStyle(column),
    onDoubleClick: !isSelectColumn ? handleDoubleClick : undefined,
    onMouseDown: handleMouseDown,
    onMouseEnter: !isSelectColumn ? handleMouseEnter : undefined,
    onMouseUp: handleMouseUp,
    tabIndex: 0,
    ...props,
    children: !column.rowGroup && /*#__PURE__*/jsxRuntime.jsxs(jsxRuntime.Fragment, {
      children: [/*#__PURE__*/jsxRuntime.jsx(column.formatter, {
        column: column,
        rowIdx: rowIdx,
        row: row,
        isCellSelected: isCellSelected,
        isRowSelected: isRowSelected,
        onRowSelectionChange: onRowSelectionChange,
        onRowChange: handleRowChange,
        onRowReorder: onRowReorder,
        enableRowRecord: enableRowRecord
      }), dragHandleProps && /*#__PURE__*/jsxRuntime.jsx("div", {
        className: cellDragHandleClassname,
        ...dragHandleProps
      })]
    })
  });
  return baseCell;
}
const MemoCell = /*#__PURE__*/React.memo( /*#__PURE__*/React.forwardRef(Cell), (prevProps, nextProps) => {
  var _prevProps$column;
  if (((_prevProps$column = prevProps.column) == null ? void 0 : _prevProps$column.key) === SELECT_COLUMN_KEY && nextProps.isRowCellSelected !== prevProps.isRowCellSelected) {
    return false;
  }
  return lodash.isEqual({
    ...prevProps,
    isMouseDown: false,
    selectedRange: '',
    isRowCellSelected: null
  }, {
    ...nextProps,
    isMouseDown: false,
    selectedRange: '',
    isRowCellSelected: null
  });
});

var css_248z$5 = ".e1ugv4o{display:contents}";
styleInject(css_248z$5);

const editorContainer = "e1ugv4o";
const editorContainerClassname = `rdg-editor-container ${editorContainer}`;
function EditorContainer({
  row,
  column,
  width,
  onRowChange,
  ...props
}) {
  var _column$editorOptions;
  const [cacheRow, setCacheRow] = React.useState(row);
  const [commitChanges, setCommitChanges] = React.useState(false);
  const handleCloseRowChange = useLatestFunc(() => {
    onRowChange({
      ...cacheRow
    }, true);
  });
  const onClickCapture = useClickOutside(handleCloseRowChange);
  const handleRowChange = (row, commitChanges = false) => {
    setCacheRow(row);
    setCommitChanges(commitChanges);
  };
  React.useEffect(() => {
    if (commitChanges) {
      onRowChange(cacheRow, true);
    }
  }, [commitChanges, cacheRow]);
  React.useEffect(() => {
    return () => {
      handleCloseRowChange();
    };
  }, []);
  if (column.editor === undefined) return null;
  const editor = /*#__PURE__*/jsxRuntime.jsx("div", {
    className: editorContainerClassname,
    onClickCapture: onClickCapture,
    children: /*#__PURE__*/jsxRuntime.jsx(column.editor, {
      width: width,
      row: cacheRow,
      column: column,
      onRowChange: handleRowChange,
      ...props
    })
  });
  if ((_column$editorOptions = column.editorOptions) != null && _column$editorOptions.createPortal) {
    return /*#__PURE__*/reactDom.createPortal(editor, props.editorPortalTarget);
  }
  return editor;
}

var css_248z$4 = ".cis5rrm{padding:0}";
styleInject(css_248z$4);

const cellEditing = "cis5rrm";
const cellEditingClassname = `rdg-cell-editing ${cellEditing}`;
function EditCell({
  className,
  column,
  row,
  rowIdx,
  width,
  editorProps,
  ...props
}) {
  const [dimensions, setDimensions] = React.useState(null);
  const cellRef = React.useCallback(node => {
    if (node !== null) {
      const {
        left,
        top
      } = node.getBoundingClientRect();
      setDimensions({
        left,
        top
      });
    }
  }, []);
  const {
    cellClass
  } = column;
  className = getCellClassname(column, cellSelectedClassname, cellEditingClassname, typeof cellClass === 'function' ? cellClass(row) : cellClass, className);
  function getCellContent() {
    var _document$scrollingEl;
    if (dimensions === null) return;
    const {
      scrollTop: docTop,
      scrollLeft: docLeft
    } = (_document$scrollingEl = document.scrollingElement) != null ? _document$scrollingEl : document.documentElement;
    const {
      left,
      top
    } = dimensions;
    const gridLeft = left + docLeft;
    const gridTop = top + docTop;
    return /*#__PURE__*/jsxRuntime.jsx(EditorContainer, {
      ...editorProps,
      width: width,
      rowIdx: rowIdx,
      column: column,
      left: gridLeft,
      top: gridTop,
      row: row
    });
  }
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    role: "gridcell",
    "aria-colindex": column.idx + 1,
    "aria-rowindex": rowIdx,
    "aria-selected": true,
    ref: cellRef,
    className: className,
    style: getCellStyle(column),
    ...props,
    children: getCellContent()
  });
}

const RowStore = /*#__PURE__*/React.createContext({
  showMenuRowIdx: null,
  topRowSet: new Set(),
  changeTopRowSet: () => {}
});

const ContextMenuStore = /*#__PURE__*/React.createContext({
  ContextMenuRender: undefined,
  getContextMenuConfig: undefined
});

const DRAG_KEY = 'DndRowIndexDnd';
function Row({
  cellRenderer: CellRenderer = MemoCell,
  className,
  rowIdx,
  isRowSelected,
  isMainSelectedRow,
  isLastRow,
  columnMetrics,
  selectedColumns,
  draggedOverCellIdx,
  lastFrozenColumnIndex,
  row,
  viewportColumns,
  selectedCellProps,
  selectedRange,
  getModifiedColumns,
  isAdd,
  isDeleted,
  onRowClick,
  rowClass,
  setDraggedOverRowIdx,
  setShowMenuRowIdx,
  getContextMenuConfig,
  ContextMenuRender,
  lazyStore,
  setMouseDown,
  onMouseEnter,
  top,
  onRowChange,
  onRowReorder,
  onGridSelect,
  enableRowRecord,
  totalColumnWidth,
  isShowRowMenu,
  'aria-rowindex': ariaRowIndex,
  'aria-selected': ariaSelected,
  ...props
}, ref) {
  function handleDragEnter(event) {
    setDraggedOverRowIdx == null || setDraggedOverRowIdx(rowIdx);
    onMouseEnter == null || onMouseEnter(event);
  }
  const dragCollect = React.useCallback(monitor => {
    return {
      isDragging: monitor.isDragging()
    };
  }, []);
  const dropCollect = React.useCallback(monitor => {
    return {
      isOver: monitor.isOver(),
      canDrop: monitor.canDrop()
    };
  }, []);
  const dropFunc = React.useCallback(({
    index,
    type,
    row: dragRow
  }) => {
    if (type === DRAG_KEY) {
      onRowReorder == null || onRowReorder(index, rowIdx);
    }
  }, [onRowReorder]);
  const drag = reactDnd.useDrag({
    type: DRAG_KEY,
    item: {
      index: rowIdx,
      type: DRAG_KEY,
      row
    },
    collect: dragCollect
  });
  const drop = reactDnd.useDrop({
    accept: DRAG_KEY,
    drop: dropFunc,
    collect: dropCollect
  });
  className = clsx(rowClassname, `rdg-row-${rowIdx % 2 === 0 ? 'even' : 'odd'}`, rowClass == null ? void 0 : rowClass(row), className, isRowSelected && rowSelectedClassname, (selectedCellProps == null ? void 0 : selectedCellProps.idx) === -1 && groupRowSelectedClassname, isShowRowMenu && rowCellShowMenuClassname, isAdd && rowIsAddClassname, isDeleted && rowIsDeleteClassname, isMainSelectedRow && rowMainSelectClassname, drop[0].isOver && dropOverRowClassName, drag[0].isDragging && dragingRowClassName);
  const cells = [];
  for (let index = 0; index < viewportColumns.length; index++) {
    var _columnMetrics$get2, _getModifiedColumns;
    const column = viewportColumns[index];
    const isCellFirstSelected = (selectedCellProps == null ? void 0 : selectedCellProps.idx) === column.idx;
    if ((selectedCellProps == null ? void 0 : selectedCellProps.mode) === 'EDIT' && isCellFirstSelected) {
      var _columnMetrics$get;
      cells.push( /*#__PURE__*/jsxRuntime.jsx(EditCell, {
        rowIdx: rowIdx,
        column: column,
        width: (_columnMetrics$get = columnMetrics.get(column)) == null ? void 0 : _columnMetrics$get.width,
        row: row,
        onKeyDown: selectedCellProps.onKeyDown,
        editorProps: selectedCellProps.editorProps
      }, column.key));
      continue;
    }
    const [minIdx, maxIdx] = [selectedRange.columnIdx, selectedRange.endColumnIdx].sort((a, b) => a - b);
    const [minRowIdx, maxRowIdx] = [selectedRange.rowIdx, selectedRange.endRowIdx].sort((a, b) => a - b);
    const isCellRangeSelected = column.idx >= minIdx && column.idx <= maxIdx && rowIdx >= minRowIdx && rowIdx <= maxRowIdx;
    cells.push( /*#__PURE__*/jsxRuntime.jsx(CellRenderer, {
      width: (_columnMetrics$get2 = columnMetrics.get(column)) == null ? void 0 : _columnMetrics$get2.width,
      rowIdx: rowIdx,
      column: column,
      columnIdx: column.idx,
      row: row,
      enableRowRecord: enableRowRecord,
      isColumnSelected: selectedColumns.has(column.key),
      drop: drop,
      drag: drag,
      isModified: (_getModifiedColumns = getModifiedColumns(row)) == null ? void 0 : _getModifiedColumns.includes(column.key),
      lazyStore: lazyStore,
      setMouseDown: setMouseDown,
      isRowCellSelected: rowIdx >= minRowIdx && rowIdx <= maxRowIdx,
      isDraggedOver: draggedOverCellIdx === column.idx,
      isCellSelected: isCellRangeSelected,
      isCellFirstSelected: isCellFirstSelected,
      isRowSelected: isRowSelected,
      dragHandleProps: isCellFirstSelected ? selectedCellProps.dragHandleProps : undefined,
      onFocus: isCellFirstSelected ? selectedCellProps.onFocus : undefined,
      onKeyDown: isCellFirstSelected ? selectedCellProps.onKeyDown : undefined,
      onGridSelect: onGridSelect,
      onRowClick: onRowClick,
      onRowChange: onRowChange,
      onRowReorder: onRowReorder,
      selectedRange: selectedRange
    }, column.key + '-' + rowIdx));
  }
  return /*#__PURE__*/jsxRuntime.jsxs("div", {
    role: "row",
    "aria-rowindex": ariaRowIndex,
    "aria-selected": ariaSelected,
    ref: ref,
    className: className,
    onMouseEnter: handleDragEnter,
    style: {
      top
    },
    ...props,
    children: [/*#__PURE__*/jsxRuntime.jsx("div", {
      ref: drag[2],
      className: clsx('rdg-drag-preview', rdgDragPreviewClassname)
    }), cells]
  });
}
const MemoRow = /*#__PURE__*/React.memo( /*#__PURE__*/React.forwardRef(Row), (prevProps, nextProps) => {
  const [oldMinRowIdx, oldMaxRowIdx] = [prevProps.selectedRange.rowIdx, prevProps.selectedRange.endRowIdx].sort((a, b) => a - b);
  const [newMinRowIdx, newMaxRowIdx] = [nextProps.selectedRange.rowIdx, nextProps.selectedRange.endRowIdx].sort((a, b) => a - b);
  const isOldInRange = oldMinRowIdx <= prevProps.rowIdx && oldMaxRowIdx >= prevProps.rowIdx;
  const isNewInRange = newMinRowIdx <= prevProps.rowIdx && newMaxRowIdx >= prevProps.rowIdx;
  if ((isOldInRange || isNewInRange) && prevProps.selectedRange != nextProps.selectedRange) {
    return false;
  }
  return lodash.isEqual({
    ...prevProps,
    selectedRange: null
  }, {
    ...nextProps,
    selectedRange: null
  });
});
function Row$1 (props) {
  const {
    showMenuRowIdx,
    setShowMenuRowIdx
  } = React.useContext(RowStore);
  const contextMenuStore = React.useContext(ContextMenuStore);
  const {
    getContextMenuConfig,
    ContextMenuRender
  } = contextMenuStore;
  return /*#__PURE__*/jsxRuntime.jsx(MemoRow, {
    getContextMenuConfig: getContextMenuConfig,
    ContextMenuRender: ContextMenuRender,
    setShowMenuRowIdx: setShowMenuRowIdx,
    isShowRowMenu: showMenuRowIdx === props.rowIdx,
    ...props
  });
}

const GridStore = /*#__PURE__*/React.createContext({
  gridRef: null
});

var css_248z$3 = ".s8wc6fl.rdg-cell.rdg-cell-frozen{background-color:var(--header-background-color);color:var(--color);padding:0}.s8wc6fl.rdg-cell.rdg-cell-frozen:hover{color:var(--color)!important}.r1runzub{-webkit-box-align:center;-ms-flex-align:center;-webkit-box-pack:justify;-webkit-align-items:center;align-items:center;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;font-size:12px;-webkit-justify-content:space-between;justify-content:space-between;padding-right:5px}.s1ot8vkx{background:var(--header-background-color)}";
styleInject(css_248z$3);

const selectCellClassName = "s8wc6fl";
const rowIndexCellClassName = "r1runzub";
const summaryCellClassname = "s1ot8vkx";
function SummaryCell({
  column,
  row
}) {
  const {
    summaryFormatter: SummaryFormatter = DefaultSummaryFormatter,
    summaryCellClass
  } = column;
  const className = getCellClassname(column, typeof summaryCellClass === 'function' ? summaryCellClass(row) : summaryCellClass, summaryCellClassname, column.key === SELECT_COLUMN_KEY && selectCellClassName);
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    role: "gridcell",
    "aria-colindex": column.idx + 1,
    className: className,
    style: getCellStyle(column),
    children: SummaryFormatter && /*#__PURE__*/jsxRuntime.jsx(SummaryFormatter, {
      column: column,
      row: row
    })
  });
}
function SelectColumnCell(props) {
  const rowStore = React.useContext(RowStore);
  const gridStore = React.useContext(GridStore);
  return /*#__PURE__*/jsxRuntime.jsxs("span", {
    className: rowIndexCellClassName,
    children: [/*#__PURE__*/jsxRuntime.jsx(antd.Tooltip, {
      showArrow: false,
      title: formatMessage("SummaryCell.SelectColumnCell.unFrozen"),
      children: /*#__PURE__*/jsxRuntime.jsx("a", {
        style: {
          marginRight: 3,
          marginLeft: 3
        },
        onClick: () => {
          var _gridStore$gridRef;
          const rowKey = (_gridStore$gridRef = gridStore.gridRef) == null ? void 0 : _gridStore$gridRef.rowKeyGetter(props.row);
          const newSet = new Set(rowStore.topRowSet);
          if (!lodash.isNil(rowKey)) {
            newSet.delete(rowKey);
            rowStore.changeTopRowSet(newSet);
          }
        },
        children: /*#__PURE__*/jsxRuntime.jsx(icons.StopOutlined, {})
      })
    }), props.row[props.column.key]]
  });
}
function DefaultSummaryFormatter(props) {
  if (props.column.key === SELECT_COLUMN_KEY) {
    return /*#__PURE__*/jsxRuntime.jsx(SelectColumnCell, {
      ...props
    });
  }
  try {
    return /*#__PURE__*/jsxRuntime.jsx(jsxRuntime.Fragment, {
      children: props.row[props.column.key]
    });
  } catch (e) {
    return null;
  }
}
const SummaryCell$1 = /*#__PURE__*/React.memo(SummaryCell);

function SummaryRow({
  rowIdx,
  row,
  viewportColumns,
  top,
  lastFrozenColumnIndex,
  isLastSummaryRow,
  'aria-rowindex': ariaRowIndex
}) {
  const cells = [];
  for (let index = 0; index < viewportColumns.length; index++) {
    const column = viewportColumns[index];
    cells.push( /*#__PURE__*/jsxRuntime.jsx(SummaryCell$1, {
      column: column,
      row: row
    }, column.key));
  }
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    role: "row",
    "aria-rowindex": ariaRowIndex,
    className: `${rowClassname} rdg-row-${rowIdx % 2 === 0 ? 'even' : 'odd'} ${summaryRowClassname} ${isLastSummaryRow ? lastSummaryRowClassname : ''}`,
    style: {
      top
    },
    children: cells
  });
}
const SummaryRow$1 = /*#__PURE__*/React.memo(SummaryRow);

const VALID_MIN_COLUMN_INDEX = 1;
function defaultOnCopy(gridRefContext) {
  const {
    selectedRange,
    selectedRows,
    selectedColumns,
    rows,
    columns,
    rowKeyGetter
  } = gridRefContext;
  const copyArr = [];
  const contentStartColIdx = columns.findIndex(col => col.key !== SELECT_COLUMN_KEY);
  const validColumns = columns.slice(contentStartColIdx);
  if (isRangeSelected(selectedRange)) {
    const {
      columnIdx,
      rowIdx,
      endColumnIdx,
      endRowIdx
    } = selectedRange;
    const _beginIdx = Math.min(Math.max(VALID_MIN_COLUMN_INDEX, columnIdx), endColumnIdx);
    const _endIdx = Math.max(Math.max(VALID_MIN_COLUMN_INDEX, columnIdx), endColumnIdx);
    const _beginRowIdx = Math.min(rowIdx, endRowIdx);
    const _endRowIdx = Math.max(rowIdx, endRowIdx);
    for (let i = _beginRowIdx; i <= _endRowIdx; i++) {
      const row = rows[i];
      const rowValue = [];
      for (let j = _beginIdx; j <= _endIdx; j++) {
        var _row$columnKey;
        const columnKey = columns[j].key;
        rowValue.push((_row$columnKey = row[columnKey]) == null || _row$columnKey.replace == null ? void 0 : _row$columnKey.replace(/\x00/g, ''));
      }
      copyArr.push(rowValue.join("\t"));
    }
  } else if (selectedRows != null && selectedRows.size) {
    for (let i = 0; i < rows.length; i++) {
      const row = rows[i];
      if (row && rowKeyGetter) {
        const rowKey = rowKeyGetter(row);
        if (selectedRows.has(rowKey)) {
          copyArr.push(validColumns.map(({
            key
          }) => {
            var _row$key;
            return (_row$key = row[key]) == null || _row$key.replace == null ? void 0 : _row$key.replace(/\x00/g, '');
          }).join("\t"));
        }
      }
    }
  } else if (selectedColumns != null && selectedColumns.size) {
    const selectedSortedColumns = [...selectedColumns].sort((leftColumnKey, rightColumnKey) => {
      const leftIdx = columns.findIndex(c => c.key === leftColumnKey);
      const rightIdx = columns.findIndex(c => c.key === rightColumnKey);
      return leftIdx - rightIdx;
    });
    for (let i = 0; i < rows.length; i++) {
      const row = rows[i];
      const rowStr = selectedSortedColumns.map(columnKey => {
        var _row$columnKey2;
        return (_row$columnKey2 = row[columnKey]) == null || _row$columnKey2.replace == null ? void 0 : _row$columnKey2.replace(/\x00/g, '');
      }).join("\t");
      copyArr.push(rowStr);
    }
  }
  const copyStr = copyArr.join("\n");
  copyToClipboard(copyStr, {
    format: 'text/plain'
  });
}
function isSelectedRows(gridRefContext) {
  var _gridRefContext$selec;
  return !!(gridRefContext != null && (_gridRefContext$selec = gridRefContext.selectedRows) != null && _gridRefContext$selec.size);
}
function eachRows(gridRefContext, rowRange, callback) {
  const {
    rows
  } = gridRefContext;
  const {
    minIndex,
    maxIndex
  } = rowRange;
  for (let i = minIndex; i <= maxIndex; i++) {
    callback(rows[i]);
  }
}
function getSelectedRowsData(gridRefContext) {
  const {
    rows,
    columns,
    selectedRows,
    rowKeyGetter
  } = gridRefContext;
  const targetColumns = columns == null ? void 0 : columns.filter(col => col.key !== SELECT_COLUMN_KEY);
  const [minRowIdx, maxRowIdx] = [0, rows.length - 1];
  const data = [];
  data.push(targetColumns.map(column => {
    return column.name;
  }));
  eachRows(gridRefContext, {
    minIndex: minRowIdx,
    maxIndex: maxRowIdx
  }, row => {
    const rowKey = rowKeyGetter(row);
    if (selectedRows != null && selectedRows.has(rowKey)) {
      data.push(targetColumns.map(column => {
        return row[column.key];
      }));
    }
  });
  return data;
}
function getSelectedRangeData(gridRefContext) {
  const {
    selectedRange,
    columns
  } = gridRefContext;
  const [minIdx, maxIdx] = [selectedRange.columnIdx, selectedRange.endColumnIdx].sort((a, b) => a - b);
  const [minRowIdx, maxRowIdx] = [selectedRange.rowIdx, selectedRange.endRowIdx].sort((a, b) => a - b);
  if (isSelectedRows(gridRefContext)) {
    return getSelectedRowsData(gridRefContext);
  }
  if (minIdx < 0 || minRowIdx < 0) {
    return null;
  }
  const data = [];
  const targetColumns = columns.slice(minIdx, maxIdx + 1);
  data.push(targetColumns.map(column => {
    return column.name;
  }));
  eachRows(gridRefContext, {
    minIndex: minRowIdx,
    maxIndex: maxRowIdx
  }, row => {
    data.push(targetColumns.map(column => {
      return row[column.key];
    }));
  });
  return data;
}

var css_248z$2 = ".cya2dq6{background-color:var(--background-primary-color);border-radius:4px;box-shadow:0 6px 16px 0 #00000014,0 3px 6px -4px #0000001f,0 9px 28px 8px #0000000d;list-style-type:none;margin:0;min-width:140px;padding:4px}.cya2dq6 .rc-menu-item,.cya2dq6 .rc-menu-submenu{line-height:20px;padding:5px 12px}.cya2dq6 .rc-menu-item:hover,.cya2dq6 .rc-menu-submenu:hover{background-color:var(--hover-color)}.cya2dq6 .rc-menu-item{cursor:pointer}.czd9rzv{padding-left:20px;position:absolute}.czd9rzv.rc-menu-submenu-hidden{display:none}.czd9rzv .rc-menu{background-color:var(--background-primary-color);border-radius:4px;box-shadow:0 6px 16px 0 #00000014,0 3px 6px -4px #0000001f,0 9px 28px 8px #0000000d;list-style-type:none;margin:0;min-width:140px;padding:4px}.czd9rzv .rc-menu .rc-menu-item,.czd9rzv .rc-menu .rc-menu-submenu{line-height:20px;padding:5px 12px}.czd9rzv .rc-menu .rc-menu-item:hover,.czd9rzv .rc-menu .rc-menu-submenu:hover{background-color:var(--hover-color)}.czd9rzv .rc-menu .rc-menu-item{cursor:pointer}";
styleInject(css_248z$2);

const cellMenuClassname = "cya2dq6";
const cellSubMenuClassname = "czd9rzv";
var MenuCommands;
(function (MenuCommands) {
  MenuCommands["odc_inner_copy"] = "odc_inner_copy";
  MenuCommands["odc_inner_add"] = "odc_inner_add";
  MenuCommands["odc_inner_delete"] = "odc_inner_delete";
  MenuCommands["odc_inner_up"] = "odc_inner_up";
  MenuCommands["odc_inner_down"] = "odc_inner_down";
  MenuCommands["odc_inner_frozen"] = "odc_inner_frozen";
  MenuCommands["odc_inner_unfreeze_all"] = "odc_inner_unfreeze_all";
  MenuCommands["odc_inner_copy_column"] = "odc_inner_copy_column";
})(MenuCommands || (MenuCommands = {}));
const DefaultContextMenuRender = props => {
  var _gridStore$gridRef, _gridStore$gridRef2, _gridStore$gridRef3, _gridStore$gridRef5;
  const {
    setContextMenuVisible,
    config,
    isRowSelected,
    isColumnSelected,
    rowIdx,
    row,
    rowKeyName
  } = props;
  const rowStore = React.useContext(RowStore);
  const gridStore = React.useContext(GridStore);
  const contextMenuStore = React.useContext(ContextMenuStore);
  const {
    onAddRows,
    onDeleteRow,
    onRowReorder,
    enableAddAction,
    enableRowRecord,
    enableRowTools,
    readonly
  } = contextMenuStore;
  const isShowTools = enableRowTools && !readonly && isRowSelected;
  const rows = gridStore == null || (_gridStore$gridRef = gridStore.gridRef) == null ? void 0 : _gridStore$gridRef.rows;
  const rowsCount = (rows == null ? void 0 : rows.length) || 0;
  const isSelectMultiRow = (((_gridStore$gridRef2 = gridStore.gridRef) == null || (_gridStore$gridRef2 = _gridStore$gridRef2.selectedRows) == null ? void 0 : _gridStore$gridRef2.size) || 0) > 1;
  const rowKey = gridStore == null || (_gridStore$gridRef3 = gridStore.gridRef) == null || _gridStore$gridRef3.rowKeyGetter == null ? void 0 : _gridStore$gridRef3.rowKeyGetter(row);
  const visibleConfig = !isRowSelected ? config : config == null ? void 0 : config.filter(item => item == null ? void 0 : item.isShowRowSelected);
  return /*#__PURE__*/jsxRuntime.jsxs(Menu, {
    "data-role": "cellMenu",
    onClick: e => {
      e.domEvent.stopPropagation();
      switch (e.key) {
        case MenuCommands.odc_inner_copy:
          {
            if (gridStore.gridRef) {
              defaultOnCopy(gridStore.gridRef);
            }
            break;
          }
        case MenuCommands.odc_inner_copy_column:
          {
            if (gridStore.gridRef) {
              defaultOnCopy(gridStore.gridRef);
            }
            break;
          }
        case MenuCommands.odc_inner_add:
          {
            onAddRows == null || onAddRows([{
              ...row,
              [rowKeyName]: generateUniqKey()
            }]);
            break;
          }
        case MenuCommands.odc_inner_delete:
          {
            onDeleteRow == null || onDeleteRow(row);
            break;
          }
        case MenuCommands.odc_inner_up:
          {
            onRowReorder == null || onRowReorder(rowIdx, rowIdx - 1);
            break;
          }
        case MenuCommands.odc_inner_down:
          {
            onRowReorder == null || onRowReorder(rowIdx, rowIdx + 1);
            break;
          }
        case MenuCommands.odc_inner_frozen:
          {
            var _gridStore$gridRef4;
            const selectRows = (_gridStore$gridRef4 = gridStore.gridRef) == null ? void 0 : _gridStore$gridRef4.selectedRows;
            if (selectRows != null && selectRows.size) {
              rowStore.changeTopRowSet(new Set([...selectRows, ...rowStore.topRowSet]));
            }
            break;
          }
        case MenuCommands.odc_inner_unfreeze_all:
          {
            rowStore.changeTopRowSet(new Set());
            break;
          }
        default:
          {
            return;
          }
      }
      setContextMenuVisible(false);
    },
    getPopupContainer: triggerNode => triggerNode.closest(".rdg") || document.body,
    className: cellMenuClassname,
    children: [isRowSelected ? /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: formatMessage("DefaultContextMenuRender.copyRow")
    }, MenuCommands.odc_inner_copy) : null, isRowSelected && (_gridStore$gridRef5 = gridStore.gridRef) != null && _gridStore$gridRef5.enableFrozenRow ? [!lodash.isNil(rowKey) && !rowStore.topRowSet.has(rowKey) ? /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: formatMessage("DefaultContextMenuRender.frozenRow")
    }, MenuCommands.odc_inner_frozen) : null, /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: formatMessage("DefaultContextMenuRender.unFrozenAll")
    }, MenuCommands.odc_inner_unfreeze_all)].filter(Boolean) : null, isColumnSelected && /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: "\u590D\u5236\u5217"
    }, MenuCommands.odc_inner_copy_column), isShowTools ? [onAddRows && enableAddAction && !isSelectMultiRow ? /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: formatMessage("DefaultContextMenuRender.newRow")
    }, MenuCommands.odc_inner_add) : null, onDeleteRow && enableAddAction && !isSelectMultiRow ? /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: formatMessage("DefaultContextMenuRender.deleteRow")
    }, MenuCommands.odc_inner_delete) : null, onRowReorder && enableRowRecord && rowIdx > 0 && !isSelectMultiRow ? /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: formatMessage("DefaultContextMenuRender.upRow")
    }, MenuCommands.odc_inner_up) : null, onRowReorder && enableRowRecord && rowIdx !== rowsCount - 1 && !isSelectMultiRow ? /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
      children: formatMessage("DefaultContextMenuRender.downRow")
    }, MenuCommands.odc_inner_down) : null].filter(Boolean) : null, visibleConfig == null ? void 0 : visibleConfig.map(c => {
      if (c.children) {
        return /*#__PURE__*/jsxRuntime.jsx(Menu.SubMenu, {
          popupClassName: cellSubMenuClassname,
          title: c.text,
          children: c.children.map(child => {
            return /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
              disabled: child.disabled,
              onClick: () => {
                child.onClick == null || child.onClick(row);
                setContextMenuVisible(false);
              },
              children: child.text
            }, child.key);
          })
        }, c.key);
      }
      return /*#__PURE__*/jsxRuntime.jsx(Menu.Item, {
        disabled: c.disabled,
        onClick: () => {
          c.onClick == null || c.onClick(row);
          setContextMenuVisible(false);
        },
        children: c.text
      }, c.key);
    })]
  });
};

const style = {
  display: 'flex',
  flex: 1,
  justifyContent: 'center',
  alignItems: 'center',
  height: '100%'
};
const DefaultEmptyRowsRenderer = () => {
  return /*#__PURE__*/jsxRuntime.jsx("div", {
    style: style,
    children: /*#__PURE__*/jsxRuntime.jsx(antd.Empty, {
      description: false
    })
  });
};

function useDragHeader(gridRef) {
  const [isHeaderDraging, setIsHeaderDraging] = React.useState(false);
  React.useEffect(() => {
    var _gridRef$current, _gridRef$current2;
    function onDragStart(e) {
      const target = e.target;
      if ((target == null ? void 0 : target.getAttribute('role')) === 'columnheader') {
        setIsHeaderDraging(true);
      }
    }
    function onDragEnd(e) {
      const target = e.target;
      if ((target == null ? void 0 : target.getAttribute('role')) === 'columnheader') {
        setIsHeaderDraging(false);
      }
    }
    (_gridRef$current = gridRef.current) == null || _gridRef$current.addEventListener('dragstart', onDragStart);
    (_gridRef$current2 = gridRef.current) == null || _gridRef$current2.addEventListener('dragend', onDragEnd);
    return () => {
      var _gridRef$current3, _gridRef$current4;
      (_gridRef$current3 = gridRef.current) == null || _gridRef$current3.removeEventListener('dragstart', onDragStart);
      (_gridRef$current4 = gridRef.current) == null || _gridRef$current4.removeEventListener('dragend', onDragEnd);
    };
  }, []);
  return isHeaderDraging;
}

var css_248z$1 = ".copjxon{box-shadow:0 3px 6px -4px #0000001f,0 6px 16px 0 #00000014,0 9px 28px 8px #0000000d;position:absolute;width:150px;z-index:1}";
styleInject(css_248z$1);

const cellContext = "copjxon";
const defaultContextInfo = {
  x: 0,
  y: 0,
  columnIdx: 0,
  rowIdx: 0,
  column: null
};
function useRowContext({
  setShowMenuRowIdx,
  getContextMenuConfig,
  ContextMenuRender = () => null,
  onGridSelect,
  viewportColumns,
  lazyStore,
  selectedRange,
  selectedRows,
  selectedColumns,
  rows,
  rowKeyName,
  rowKeyGetter,
  scrollTop,
  headerRowsCount
}) {
  const [contextMenuVisible, setContextMenuVisible] = React.useState(false);
  const [contextInfo, setContextInfo] = React.useState(defaultContextInfo);
  const contextRef = React.useRef(null);
  const {
    rowIdx,
    columnIdx
  } = contextInfo;
  const row = rows == null ? void 0 : rows[rowIdx];
  const column = viewportColumns.find(c => c.idx === columnIdx);
  const ariaRowIndex = headerRowsCount + rowIdx + 1;
  const setIsShowMenu = React.useCallback(v => {
    setContextMenuVisible(v);
    setShowMenuRowIdx == null || setShowMenuRowIdx(rowIdx, v);
  }, [setContextMenuVisible, setShowMenuRowIdx, rowIdx]);
  const handleResetContext = () => {
    setContextInfo(defaultContextInfo);
  };
  const _innerRef = React.useRef();
  _innerRef.current = setIsShowMenu;
  React.useEffect(() => {
    return () => {
      _innerRef.current == null || _innerRef.current(false);
    };
  }, []);
  React.useEffect(() => {
    function hideContextMenu() {
      if (contextMenuVisible) {
        setIsShowMenu(false);
        handleResetContext();
      }
    }
    function _contextMenu(event) {
      var _event$target;
      if (((_event$target = event.target) == null || _event$target.closest == null ? void 0 : _event$target.closest('.rdg-row')) !== document.querySelector(`[aria-rowindex="${ariaRowIndex}"]`)) {
        setIsShowMenu(false);
      }
    }
    window.addEventListener('click', hideContextMenu);
    if (contextMenuVisible) {
      window.addEventListener('contextmenu', _contextMenu);
    }
    return () => {
      window.removeEventListener('click', hideContextMenu);
      window.removeEventListener('contextmenu', _contextMenu);
    };
  }, [contextMenuVisible, setIsShowMenu]);
  function onRowSelectionChange(rowIdx, isShiftClick, isCtrlClick) {
    onGridSelect({
      rowIdx,
      columnIdx: -1,
      isShiftClick,
      isCtrlClick
    });
  }
  function handleContextMenu(event) {
    var _findNode;
    event.preventDefault();
    event.stopPropagation();
    let x = 0,
      y = 0;
    const target = event.target;
    function findNode(node) {
      if (!node) {
        return;
      } else if (['columnheader', 'gridcell'].includes(node.getAttribute('role'))) {
        var _node$parentElement, _lazyStore$get$curren, _contextRef$current;
        const cellRect = (_node$parentElement = node.parentElement) == null ? void 0 : _node$parentElement.getBoundingClientRect();
        const gridRect = (_lazyStore$get$curren = lazyStore.get('gridRef').current) == null ? void 0 : _lazyStore$get$curren.getBoundingClientRect();
        const contextRect = (_contextRef$current = contextRef.current) == null ? void 0 : _contextRef$current.getBoundingClientRect();
        const gridRight = gridRect == null ? void 0 : gridRect.right;
        const maxTop = (gridRect == null ? void 0 : gridRect.height) - (contextRect == null ? void 0 : contextRect.height) + scrollTop - 12;
        if (cellRect) {
          x = event.pageX - cellRect.left;
          if (event.pageX + 130 > gridRight) {
            x = x - 130;
          }
          y = Math.min(event.pageY - (gridRect == null ? void 0 : gridRect.top) + scrollTop, maxTop);
        }
        return {
          columnIdx: parseInt(node.getAttribute('aria-colindex')) - 1,
          rowIdx: parseInt(node.getAttribute('aria-rowindex'))
        };
      } else if (node.getAttribute('role') === 'row') {
        return;
      }
      return findNode(node.parentElement);
    }
    const {
      columnIdx,
      rowIdx
    } = (_findNode = findNode(target)) != null ? _findNode : {};
    const column = viewportColumns.find(c => c.idx === columnIdx);
    const rowKey = rowKeyGetter(rows == null ? void 0 : rows[rowIdx]);
    if (lodash.isNil(columnIdx) || !column) {
      return;
    }
    const isRowSelected = column.key === SELECT_COLUMN_KEY;
    if (isRowSelected) {
      if (!selectedRows.has(rowKey)) {
        onRowSelectionChange(rowIdx, event.nativeEvent.shiftKey, isCtrlDown(event));
      }
    } else {
      if (!selectedColumns.has(column.key) && !selectedRows.has(rowKey) && !isCellInRange(columnIdx, rowIdx, selectedRange)) {
        onGridSelect({
          columnIdx: column.idx,
          rowIdx
        });
      }
    }
    if (!contextMenuVisible) {
      setIsShowMenu(true);
    }
    if (x || y) {
      setContextInfo({
        x,
        y,
        columnIdx,
        rowIdx,
        column
      });
    }
    return false;
  }
  const isShowContext = contextMenuVisible && ContextMenuRender;
  return {
    contextMenuElement: column ? /*#__PURE__*/jsxRuntime.jsx("div", {
      className: cellContext,
      ref: contextRef,
      style: {
        position: 'absolute',
        left: contextInfo == null ? void 0 : contextInfo.x,
        top: contextInfo == null ? void 0 : contextInfo.y,
        zIndex: isShowContext ? 4 : -1,
        opacity: isShowContext ? 1 : 0
      },
      children: /*#__PURE__*/jsxRuntime.jsx(ContextMenuRender, {
        row: row,
        rowKeyName: rowKeyName,
        columnKey: column.key,
        selectedRange: selectedRange,
        contextMenuVisible: contextMenuVisible,
        setContextMenuVisible: () => {
          setIsShowMenu(false);
        },
        config: getContextMenuConfig == null ? void 0 : getContextMenuConfig(row, column),
        isRowSelected: !!selectedRows.size,
        isColumnSelected: !!selectedColumns.size,
        rowIdx: rowIdx
      })
    }) : null,
    handleContextMenu,
    handleResetContext
  };
}

var _globalThis$document;
const body = (_globalThis$document = globalThis.document) == null ? void 0 : _globalThis$document.body;
const headerRowsCount = 1;
const SCROLL_THROTTLE_TIME = 16;
const C_KEY = 67;
const V_KEY = 86;
const FILTER_NULL_KEY = '(null)';
const FILTER_EMPTY_KEY = '(empty)';
const getRowFilterOptions = options => {
  var _filterColumns;
  const {
    tag = 'add',
    rowKeyName,
    enableFilterRow,
    columns,
    rows,
    updateRows,
    preFilterOptions = {}
  } = options;
  let filterColumns = [];
  if (!enableFilterRow) {
    filterColumns = [];
  } else {
    filterColumns = columns.filter(({
      filterable = true
    }) => filterable);
  }
  if (!filterColumns.length) {
    return null;
  }
  const nextFilterOptions = {
    ...preFilterOptions
  };
  if (lodash.isEmpty(preFilterOptions)) {
    filterColumns.forEach(c => {
      nextFilterOptions[c.key] = new Set();
    });
  }
  const newFilterColumns = (_filterColumns = filterColumns) == null ? void 0 : _filterColumns.filter(column => !nextFilterOptions[column.key]);
  if (newFilterColumns != null && newFilterColumns.length) {
    newFilterColumns.forEach(c => {
      nextFilterOptions[c.key] = new Set();
    });
    rows.forEach(row => {
      newFilterColumns.forEach(c => {
        const key = c.key;
        const v = row[key];
        if (v === null) {
          nextFilterOptions[key].add(FILTER_NULL_KEY);
        } else if (typeof v === 'string' && !v.trim()) {
          nextFilterOptions[key].add(FILTER_EMPTY_KEY);
        } else if (typeof v !== 'undefined') {
          nextFilterOptions[key].add(v);
        }
      });
    });
  }
  updateRows.forEach(row => {
    filterColumns.forEach(c => {
      const key = c.key;
      const v = row[key];
      if (v === null) {
        nextFilterOptions[key].add(FILTER_NULL_KEY);
      } else if (typeof v === 'string' && !v.trim()) {
        nextFilterOptions[key].add(FILTER_EMPTY_KEY);
      } else if (typeof v !== 'undefined') {
        if (['delete', 'modmifined'].includes(tag)) {
          const preRow = rows == null ? void 0 : rows.find(item => (item == null ? void 0 : item[rowKeyName]) === (row == null ? void 0 : row[rowKeyName]));
          const index = rows == null ? void 0 : rows.findIndex(item => (item == null ? void 0 : item[key]) === (preRow == null ? void 0 : preRow[key]));
          const lastIndex = rows == null ? void 0 : rows.findLastIndex(item => (item == null ? void 0 : item[key]) === (preRow == null ? void 0 : preRow[key]));
          const isOnlyOne = index === lastIndex && index !== -1;
          if (tag === 'delete') {
            if (isOnlyOne) {
              nextFilterOptions[key].delete(v);
            }
          } else {
            if (isOnlyOne) {
              nextFilterOptions[key].delete(preRow == null ? void 0 : preRow[key]);
            }
            nextFilterOptions[key].add(v);
          }
        } else {
          nextFilterOptions[key].add(v);
        }
      }
    });
  });
  return nextFilterOptions;
};
function DataGrid({
  initialColumns,
  initialRows,
  rowKeyName = '__id',
  onRowsChange,
  onSelectChange,
  rowRenderer: RowRenderer = Row$1,
  emptyRowsRenderer: EmptyRowsRenderer = DefaultEmptyRowsRenderer,
  onCopy = defaultOnCopy,
  onFill,
  defaultColumnOptions,
  contextMenuRender = DefaultContextMenuRender,
  getContextMenuConfig,
  editorPortalTarget = body,
  className,
  style,
  rowClass,
  pasteFormatter,
  options
}, ref) {
  var _summaryRows$length;
  const {
    rowHeight = 35
  } = options != null ? options : {};
  const {
    theme = 'white',
    headerRowHeight = rowHeight,
    headerFiltersHeight = 45,
    summaryRowHeight = rowHeight,
    enableFilterRow = false,
    enableSortRow = false,
    enableSelect = true,
    enableVirtualization = true,
    enableRowRecord = false,
    enableRowTools = true,
    enableFrozenRow = false,
    enableAddRow = true,
    enableFlushDelete = false,
    searchKey = '',
    aria,
    cellNavigationMode = 'NONE'
  } = options != null ? options : {};
  const [scrollTop, setScrollTop] = React.useState(0);
  const [scrollLeft, setScrollLeft] = React.useState(0);
  const [columnWidths, setColumnWidths] = React.useState(() => new Map());
  const [isDragging, setDragging] = React.useState(false);
  const [draggedOverRowIdx, setOverRowIdx] = React.useState(undefined);
  const [, forceUpdate] = React.useState('');
  const [showMenuRowIdx, _setShowMenuRowIdx] = React.useState(-1);
  const [topRowSet, _changeTopRowSet] = React.useState(new Set());
  const [rawRows, setRows] = React.useState(initialRows);
  const [rawColumns, setColumns] = React.useState(() => {
    return [SelectColumn].concat(initialColumns);
  });
  const [rowFilters, _setRowFilters] = React.useState({});
  const [rowFilterOptions, setRowFilterOptions] = React.useState(() => {
    return getRowFilterOptions({
      enableFilterRow,
      columns: rawColumns,
      rows: rawRows,
      updateRows: rawRows,
      rowKeyName
    });
  });
  const readonlyRef = useLatest(options == null ? void 0 : options.readonly);
  const rowKeyGetter = React.useCallback(row => {
    return row == null ? void 0 : row[rowKeyName];
  }, [rowKeyName]);
  const countMap = React.useRef(new Map());
  const setShowMenuRowIdx = React.useCallback(function (rowIdx, isShow = true) {
    let count = countMap.current.get(rowIdx) || 0;
    if (isShow) {
      count++;
    } else {
      count--;
    }
    if (count > 0) {
      countMap.current.set(rowIdx, count);
    } else if (countMap.current.has(rowIdx)) {
      countMap.current.delete(rowIdx);
    }
    const rowIdxs = [...countMap.current.keys()];
    if (rowIdxs.length === 0) {
      _setShowMenuRowIdx(-1);
    } else {
      _setShowMenuRowIdx(rowIdxs == null ? void 0 : rowIdxs[0]);
    }
  }, [_setShowMenuRowIdx, showMenuRowIdx, countMap]);
  const lazyStore = React.useMemo(() => {
    return new Map([['isMouseDown', false]]);
  }, []);
  const isMouseDown = lazyStore.get('isMouseDown');
  const setMouseDown = React.useCallback(v => {
    lazyStore.set('isMouseDown', v);
    forceUpdate(Math.random() + '');
  }, []);
  const [sortInfo, setSortInfo] = React.useState({
    columnKey: '',
    direction: 'NONE'
  });
  const innerOnSort = React.useCallback((columnKey, direction) => {
    var _focusSinkRef$current;
    setSortInfo({
      columnKey,
      direction
    });
    (_focusSinkRef$current = focusSinkRef.current) == null || _focusSinkRef$current.focus();
  }, [setSortInfo]);
  const [gridRef, gridWidth, gridHeight] = useGridDimensions();
  const summaryRows = React.useMemo(() => rawRows.filter(row => {
    return topRowSet.has(rowKeyGetter(row));
  }), [rawRows, topRowSet, rowKeyGetter]);
  const {
    deletedRowKeys,
    newRowKeys,
    modifiedRowKeys
  } = React.useMemo(() => {
    const deletedRowKeys = new Set();
    const newRowKeys = new Set();
    const modifiedRowKeys = new Set();
    for (let index = 0; index < rawRows.length; index++) {
      const row = rawRows[index];
      const key = rowKeyGetter(row);
      if (row._created) {
        newRowKeys.add(key);
      } else if (row._originRow) {
        modifiedRowKeys.add(key);
      } else if (row._deleted) {
        deletedRowKeys.add(key);
      }
    }
    return {
      deletedRowKeys,
      newRowKeys,
      modifiedRowKeys
    };
  }, [rawRows, rowKeyGetter]);
  const summaryRowsCount = (_summaryRows$length = summaryRows == null ? void 0 : summaryRows.length) != null ? _summaryRows$length : 0;
  const totalHeaderHeight = headerRowHeight + summaryRows.length * summaryRowHeight;
  const clientHeight = gridHeight - totalHeaderHeight;
  const {
    isMouseInElement,
    mouseLeaveEvent
  } = useMouse(gridRef, isMouseDown);
  const changeTopRowSet = React.useCallback(newSet => {
    if (topRowSet.size > newSet.size) {
      _changeTopRowSet(newSet);
      return;
    }
    if ((newSet.size + 2) * summaryRowHeight > gridHeight - totalHeaderHeight) {
      antd.message.warning(formatMessage('DataGrid.changeTopRowSet.tooMuchFrozen'));
    } else {
      _changeTopRowSet(newSet);
    }
  }, [gridHeight, _changeTopRowSet, topRowSet]);
  const {
    columns,
    colOverscanStartIdx,
    colOverscanEndIdx,
    layoutCssVars,
    columnMetrics,
    totalColumnWidth,
    lastFrozenColumnIndex,
    totalFrozenColumnWidth,
    colVisibleStartIdx = 0,
    colVisibleEndIdx = 0
  } = useCalculatedColumns({
    rowsCount: rawRows.length,
    rawColumns,
    columnWidths,
    scrollLeft,
    viewportWidth: gridWidth,
    defaultColumnOptions,
    enableVirtualization,
    readonly: readonlyRef.current
  });
  const {
    rowOverscanStartIdx,
    rowOverscanEndIdx,
    rowVisibleStartIdx = 0,
    rowVisibleEndIdx = 0,
    rows,
    rowsCount
  } = useViewportRows({
    rawRows,
    rowHeight,
    clientHeight,
    scrollTop,
    enableVirtualization,
    sortInfo,
    rawColumns,
    rowFilters,
    searchKey
  });
  const minColIdx = 0;
  lazyStore.set('gridWidth', gridWidth);
  lazyStore.set('gridHeight', gridHeight);
  lazyStore.set('gridRef', gridRef);
  const isCellWithinRange = React.useCallback(function isCellWithinRange({
    columnIdx,
    rowIdx,
    endRowIdx,
    endColumnIdx
  }) {
    return rowIdx >= 0 && rowIdx < rawRows.length && columnIdx >= minColIdx && columnIdx < columns.length && endColumnIdx >= 0 && endRowIdx < rawRows.length && endColumnIdx >= minColIdx && endColumnIdx < columns.length;
  }, [columns, rawRows]);
  const viewportColumns = useViewportColumns({
    columns,
    colOverscanStartIdx,
    colOverscanEndIdx
  });
  const {
    isSelectedRangeEditable,
    selectedRange,
    selectedRows,
    selectedColumns,
    handleSelect
  } = useSelection(rows, columns, isCellWithinRange, rowKeyGetter, onSelectChange);
  const setRowFilters = React.useCallback(value => {
    _setRowFilters(value);
  }, [_setRowFilters, handleSelect]);
  const focusSinkRef = React.useRef(null);
  const prevSelectedPosition = React.useRef(selectedRange);
  const prevSelectedRows = React.useRef(selectedRows);
  const prevSelectedColumn = React.useRef(selectedColumns);
  const latestDraggedOverRowIdx = React.useRef(draggedOverRowIdx);
  const isCellFocusable = React.useRef(false);
  const {
    contextMenuElement,
    handleContextMenu,
    handleResetContext
  } = useRowContext({
    setShowMenuRowIdx,
    getContextMenuConfig,
    ContextMenuRender: contextMenuRender,
    onGridSelect: handleSelect,
    viewportColumns,
    lazyStore,
    selectedRange,
    selectedRows,
    selectedColumns,
    rows,
    rowKeyName,
    rowKeyGetter,
    scrollTop,
    headerRowsCount
  });
  const selectCellAndCommitEdit = React.useCallback((position, isShiftClick = false, enableEditor = false) => {
    const {
      columnIdx,
      rowIdx
    } = position;
    handleSelect({
      rowIdx: rowIdx,
      columnIdx,
      isUpdateIndex: true,
      isShiftClick,
      enableEditor
    });
    commitEditorChanges();
  }, [handleSelect, commitEditorChanges]);
  const handleFormatterRowChangeLatest = useLatestFunc(updateSingleRow);
  const onRowReorder = React.useCallback((sourceIndex, targetIndex) => {
    const newRows = [...rows];
    newRows.splice(targetIndex, 0, newRows.splice(sourceIndex, 1)[0]);
    setRows(newRows);
    onRowsChange == null || onRowsChange(newRows);
  }, [rows, rowKeyGetter]);
  const onColumnReorder = React.useCallback((sourceKey, targetColumnKey) => {
    const newColumns = [...rawColumns];
    const srcIdx = newColumns.findIndex(r => r.key === sourceKey);
    const targetIdx = newColumns.findIndex(r => r.key === targetColumnKey);
    newColumns.splice(targetIdx > srcIdx ? targetIdx - 1 : targetIdx, 0, newColumns.splice(srcIdx, 1)[0]);
    setColumns(newColumns);
  }, [rawColumns]);
  const _setRows = rows => {
    const rowFilterOptions = getRowFilterOptions({
      enableFilterRow,
      columns: rawColumns,
      rows,
      updateRows: rows,
      rowKeyName
    });
    setRows(rows);
    setRowFilterOptions(rowFilterOptions);
  };
  const _setColumns = columns => {
    var _columns$;
    const hasSelectColumn = ((_columns$ = columns[0]) == null ? void 0 : _columns$.key) === SELECT_COLUMN_KEY;
    const _columns = hasSelectColumn ? columns : [SelectColumn].concat(columns);
    const rowFilterOptions = getRowFilterOptions({
      enableFilterRow,
      columns: _columns,
      rows: rawRows,
      updateRows: rawRows,
      rowKeyName
    });
    handleResetContext();
    setColumns(_columns);
    setRowFilterOptions(rowFilterOptions);
  };
  const setCellsByRowIndex = (rowIdx, cells) => {
    updateSingleRow({
      ...rawRows[rowIdx],
      ...cells
    });
  };
  const getCellsByRowIndex = rowIdx => {
    return rawRows[rowIdx];
  };
  const refContext = React.useMemo(() => ({
    element: gridRef.current,
    columns: rawColumns,
    rows,
    selectedRange,
    selectedRows,
    selectedColumns,
    enableFrozenRow,
    rowKeyName,
    setRows: _setRows,
    setColumns: _setColumns,
    addRows: onAddRows,
    deleteRows: onDeleteRow,
    onRowReorder,
    scroll(idx, rowIdx, force) {},
    scrollToColumn(columnIdx) {
      scrollToCell({
        columnIdx
      });
    },
    scrollToRow(rowIdx, force) {
      scrollToCell({
        rowIdx
      }, force);
    },
    scrollToNextPage() {
      var _gridRef$current;
      (_gridRef$current = gridRef.current) == null || _gridRef$current.scrollTo({
        top: scrollTop + clientHeight
      });
    },
    scrollToPrevPage() {
      var _gridRef$current2;
      (_gridRef$current2 = gridRef.current) == null || _gridRef$current2.scrollTo({
        top: Math.max(scrollTop - clientHeight, 0)
      });
    },
    selectCell: selectCellAndCommitEdit,
    rowKeyGetter,
    setCellsByRowIndex,
    getCellsByRowIndex
  }), [gridRef, scrollTop, scrollToCell, clientHeight, selectCellAndCommitEdit, rows, columns, selectedRows, selectedColumns, selectedRange, rowKeyGetter, enableFrozenRow, rowVisibleEndIdx, rowVisibleStartIdx]);
  const patchRows = React.useCallback(function patchRows(data) {
    var _data$modifiedRows, _data$deletedRows, _data$newRows, _nextRows;
    if (readonlyRef.current) {
      return;
    }
    let nextRows = [...rawRows];
    let filterTag = 'add';
    let filterRows = [];
    if ((_data$modifiedRows = data.modifiedRows) != null && _data$modifiedRows.length) {
      var _data$modifiedRows2;
      filterTag = 'modmifined';
      filterRows = data.modifiedRows;
      (_data$modifiedRows2 = data.modifiedRows) == null || _data$modifiedRows2.forEach(nextRow => {
        const idx = nextRows.findIndex(item => rowKeyGetter(item) === rowKeyGetter(nextRow));
        if (idx > -1) {
          var _nextRows$idx, _nextRows$idx2;
          nextRows[idx] = nextRow;
          if ((_nextRows$idx = nextRows[idx]) != null && _nextRows$idx._deleted || (_nextRows$idx2 = nextRows[idx]) != null && _nextRows$idx2._created) return;
          nextRows[idx] = {
            ...nextRow,
            modified: true
          };
          if (!nextRows[idx]._originRow) {
            nextRows[idx] = {
              ...nextRows[idx],
              _originRow: rawRows[idx]
            };
          }
        }
      });
    }
    if ((_data$deletedRows = data.deletedRows) != null && _data$deletedRows.length) {
      filterTag = 'delete';
      filterRows = data.deletedRows;
      data.deletedRows.forEach(row => {
        const srcIdx = rawRows.findIndex(r => rowKeyGetter(row) === rowKeyGetter(r));
        if (row._created || enableFlushDelete) {
          nextRows[srcIdx] = null;
          return;
        }
        nextRows[srcIdx] = {
          ...nextRows[srcIdx],
          _deleted: true
        };
      });
    }
    if ((_data$newRows = data.newRows) != null && _data$newRows.length) {
      filterRows = data.newRows;
      let rowIdx = rawRows.length;
      if (selectedRows != null && selectedRows.size) {
        const rawRowIndexs = rawRows.map((row, idx) => selectedRows != null && selectedRows.has(rowKeyGetter(row)) ? idx : null).filter(a => a !== null);
        rowIdx = Math.max(...rawRowIndexs);
      }
      nextRows.splice(rowIdx + 1, 0, ...data.newRows);
      setTimeout(() => {
        scrollToCell({
          rowIdx: rowIdx + 1
        }, false);
      }, 0);
    }
    nextRows = (_nextRows = nextRows) == null ? void 0 : _nextRows.filter(Boolean);
    const nextFilterOptions = getRowFilterOptions({
      enableFilterRow,
      columns: rawColumns,
      rows: rawRows,
      tag: filterTag,
      updateRows: filterRows,
      preFilterOptions: rowFilterOptions,
      rowKeyName
    });
    setRows(nextRows);
    onRowsChange == null || onRowsChange(nextRows);
    setRowFilterOptions(nextFilterOptions);
  }, [rawRows, rawColumns, rowFilterOptions, selectedRows, readonlyRef, rowKeyGetter]);
  const handlePaste = usePaste({
    gridContext: refContext,
    patchRows,
    pasteFormatter
  });
  const enableCellDragAndDrop = onFill !== undefined;
  React.useLayoutEffect(() => {
    var _prevSelectedPosition, _prevSelectedPosition2, _prevSelectedPosition3, _prevSelectedPosition4;
    const isSelectedCellNoChange = (selectedRange == null ? void 0 : selectedRange.columnIdx) === ((_prevSelectedPosition = prevSelectedPosition.current) == null ? void 0 : _prevSelectedPosition.columnIdx) && (selectedRange == null ? void 0 : selectedRange.rowIdx) === ((_prevSelectedPosition2 = prevSelectedPosition.current) == null ? void 0 : _prevSelectedPosition2.rowIdx) && (selectedRange == null ? void 0 : selectedRange.endColumnIdx) === ((_prevSelectedPosition3 = prevSelectedPosition.current) == null ? void 0 : _prevSelectedPosition3.endColumnIdx) && (selectedRange == null ? void 0 : selectedRange.endRowIdx) === ((_prevSelectedPosition4 = prevSelectedPosition.current) == null ? void 0 : _prevSelectedPosition4.endRowIdx);
    if (isSelectedCellNoChange || selectedRange.mode === RangeMode.EDIT || !isCellWithinRange(selectedRange)) {
      if (prevSelectedRows.current != selectedRows) {
        if (selectedRows != null && selectedRows.size) {
          var _focusSinkRef$current2;
          (_focusSinkRef$current2 = focusSinkRef.current) == null || _focusSinkRef$current2.focus({
            preventScroll: true
          });
        }
      } else if (prevSelectedColumn.current !== selectedColumns) {
        if (selectedColumns.size) {
          var _focusSinkRef$current3;
          (_focusSinkRef$current3 = focusSinkRef.current) == null || _focusSinkRef$current3.focus({
            preventScroll: true
          });
        }
      }
      prevSelectedRows.current = selectedRows;
      prevSelectedColumn.current = selectedColumns;
      return;
    }
    prevSelectedRows.current = selectedRows;
    prevSelectedPosition.current = selectedRange;
    if (isCellFocusable.current) {
      isCellFocusable.current = false;
      return;
    }
    setTimeout(() => {
      var _document$activeEleme;
      if ((_document$activeEleme = document.activeElement) != null && _document$activeEleme.contains(focusSinkRef.current)) {
        var _focusSinkRef$current4;
        (_focusSinkRef$current4 = focusSinkRef.current) == null || _focusSinkRef$current4.focus({
          preventScroll: true
        });
      }
    });
  });
  React.useEffect(() => {
    function handleMouseUp() {
      if (lazyStore.get('isMouseDown')) {
        setMouseDown(false);
      }
    }
    window.addEventListener('mouseup', handleMouseUp);
    return () => {
      window.removeEventListener('mouseup', handleMouseUp);
    };
  }, [lazyStore]);
  React.useEffect(() => {
    function onPaste(e) {
      var _document$activeEleme2;
      if (focusSinkRef.current === document.activeElement || ((_document$activeEleme2 = document.activeElement) == null ? void 0 : _document$activeEleme2.getAttribute("role")) === 'gridcell') {
        var _e$clipboardData;
        const text = e == null || (_e$clipboardData = e.clipboardData) == null ? void 0 : _e$clipboardData.getData('text');
        if (text) {
          handlePaste(text);
        }
      }
    }
    if (!readonlyRef.current) {
      document.addEventListener('paste', onPaste);
    }
    return () => {
      document.removeEventListener('paste', onPaste);
    };
  }, [focusSinkRef, readonlyRef, handlePaste]);
  React.useEffect(() => {
    handleSelect({
      rowIdx: 0,
      columnIdx: 1,
      isUpdateIndex: true
    });
  }, [rowFilters]);
  React.useImperativeHandle(ref, () => refContext, [refContext]);
  const handleColumnResize = React.useCallback((column, width) => {
    setColumnWidths(columnWidths => {
      const newColumnWidths = new Map(columnWidths);
      newColumnWidths.set(column.key, width);
      return newColumnWidths;
    });
  }, []);
  const setDraggedOverRowIdx = React.useCallback(rowIdx => {
    setOverRowIdx(rowIdx);
    latestDraggedOverRowIdx.current = rowIdx;
  }, []);
  function onGridFocus() {
    if (!isCellWithinRange(selectedRange) && !(selectedRows != null && selectedRows.size) && !selectedColumns.size) {
      const initialPosition = {
        columnIdx: 1,
        rowIdx: 0,
        mode: RangeMode.SELECT,
        endColumnIdx: 1,
        endRowIdx: 0
      };
      if (isCellWithinRange(initialPosition)) {
        const {
          columnIdx,
          rowIdx
        } = initialPosition;
        handleSelect({
          columnIdx,
          rowIdx: rowIdx,
          mode: RangeMode.SELECT
        });
      }
    }
  }
  function handleCopy(event) {
    var _gridRef$current3;
    const {
      keyCode
    } = event;
    const target = event.target;
    if (!target || !((_gridRef$current3 = gridRef.current) != null && _gridRef$current3.contains(target))) {
      return;
    }
    if (isCtrlKeyHeldDown(event) && (isCellWithinRange(selectedRange) || ((selectedRows == null ? void 0 : selectedRows.size) || -1) > 0 || !!selectedColumns.size) && selectedRange.mode === RangeMode.SELECT) {
      if (keyCode === C_KEY) {
        onCopy == null || onCopy(refContext);
        return;
      }
      if (keyCode === V_KEY) {
        return;
      }
    }
  }
  function handleKeyDown(event) {
    var _gridRef$current4;
    const target = event.target;
    if (!target || !((_gridRef$current4 = gridRef.current) != null && _gridRef$current4.contains(target))) {
      return;
    }
    if (isCtrlKeyHeldDown(event) && (isCellWithinRange(selectedRange) || ((selectedRows == null ? void 0 : selectedRows.size) || -1) > 0 || !!selectedColumns.size) && selectedRange.mode === RangeMode.SELECT) {
      if ([C_KEY, V_KEY].includes(event == null ? void 0 : event.keyCode)) {
        return;
      }
    }
    switch (event.key) {
      case 'Escape':
        closeEditor();
        return;
      case 'ArrowUp':
      case 'ArrowDown':
      case 'ArrowLeft':
      case 'ArrowRight':
      case 'Tab':
      case 'Home':
      case 'End':
      case 'PageUp':
      case 'PageDown':
        navigate(event);
        break;
      default:
        handleCellInput(event);
        break;
    }
  }
  function handleFocus() {
    isCellFocusable.current = true;
  }
  const updateScrollState = React.useCallback(lodash.throttle(function handleScroll(scrollTop, scrollLeft) {
    setScrollTop(scrollTop);
    setScrollLeft(scrollLeft);
  }, 100), [setScrollTop, setScrollLeft]);
  const handleScroll = function handleScroll(event) {
    var _event$currentTarget, _event$currentTarget2;
    updateScrollState(event == null || (_event$currentTarget = event.currentTarget) == null ? void 0 : _event$currentTarget.scrollTop, event == null || (_event$currentTarget2 = event.currentTarget) == null ? void 0 : _event$currentTarget2.scrollLeft);
  };
  function onAddRows(rows) {
    const newRows = rows == null ? void 0 : rows.map(item => ({
      ...item,
      _created: true
    }));
    patchRows({
      newRows
    });
  }
  function onDeleteRow() {
    var _selectedKeys;
    let selectedKeys = new Set();
    if (selectedRows != null && selectedRows.size) {
      selectedKeys = selectedRows;
    } else if (selectedRange.rowIdx != -1) {
      const maxIdx = Math.max(selectedRange.rowIdx, selectedRange.endRowIdx);
      const minIdx = Math.min(selectedRange.rowIdx, selectedRange.endRowIdx);
      selectedKeys = new Set(rows.slice(minIdx, maxIdx + 1).map(row => rowKeyGetter(row)));
    }
    if (!((_selectedKeys = selectedKeys) != null && _selectedKeys.size)) {
      return;
    }
    const deletedRows = rows.filter(row => {
      var _selectedKeys2;
      return (_selectedKeys2 = selectedKeys) == null ? void 0 : _selectedKeys2.has(rowKeyGetter(row));
    });
    patchRows({
      deletedRows
    });
  }
  function updateSingleRow(row) {
    const idx = rawRows.findIndex(r => {
      return rowKeyGetter(row) === rowKeyGetter(r);
    });
    if (idx != -1) {
      patchRows({
        modifiedRows: [row],
        indexes: [idx],
        column: columns[selectedRange.columnIdx]
      });
    }
  }
  function commitEditorChanges() {
    var _columns$selectedRang;
    const row = rows[selectedRange.rowIdx];
    if (((_columns$selectedRang = columns[selectedRange.columnIdx]) == null ? void 0 : _columns$selectedRang.editor) === undefined || selectedRange.mode === RangeMode.SELECT || row === row._originRow) {
      return;
    }
    updateSingleRow(row);
  }
  function handleCellInput(event) {
    var _column$editorOptions;
    if (!isCellWithinRange(selectedRange)) return;
    const {
      key
    } = event;
    const column = columns[selectedRange.columnIdx];
    if (selectedRange.mode === RangeMode.EDIT) {
      if (key === 'Enter' && !event.shiftKey) {
        commitEditorChanges();
        closeEditor();
      }
      return;
    }
    (_column$editorOptions = column.editorOptions) == null || _column$editorOptions.onCellKeyDown == null || _column$editorOptions.onCellKeyDown(event);
    if (event.isDefaultPrevented()) return;
    if (isSelectedRangeEditable && isDefaultCellInput(event) && !readonlyRef.current) {
      if (key === 'Enter') {
        event.preventDefault();
      }
      handleSelect({
        ...selectedRange,
        isUpdateIndex: true,
        mode: RangeMode.EDIT
      });
    }
  }
  function handleDragEnd() {
    const overRowIdx = latestDraggedOverRowIdx.current;
    if (overRowIdx === undefined || !onFill || !onRowsChange) return;
    const {
      columnIdx,
      rowIdx
    } = selectedRange;
    const sourceRow = rawRows[rowIdx];
    const startRowIndex = rowIdx < overRowIdx ? rowIdx + 1 : overRowIdx;
    const endRowIndex = rowIdx < overRowIdx ? overRowIdx + 1 : rowIdx;
    const targetRows = rawRows.slice(startRowIndex, endRowIndex);
    const column = columns[columnIdx];
    const updatedTargetRows = onFill({
      columnKey: column.key,
      sourceRow,
      targetRows
    });
    const updatedRows = [];
    for (let i = startRowIndex; i < endRowIndex; i++) {
      const nextRow = updatedTargetRows[i - startRowIndex];
      updatedRows.push(nextRow);
    }
    patchRows({
      modifiedRows: updatedRows
    });
    setDraggedOverRowIdx(undefined);
  }
  function handleMouseDown(event) {
    if (event.buttons !== 1) return;
    setDragging(true);
    window.addEventListener('mouseover', onMouseOver);
    window.addEventListener('mouseup', onMouseUp);
    function onMouseOver(event) {
      if (event.buttons !== 1) onMouseUp();
    }
    function onMouseUp() {
      window.removeEventListener('mouseover', onMouseOver);
      window.removeEventListener('mouseup', onMouseUp);
      setDragging(false);
      handleDragEnd();
    }
  }
  function handleDoubleClick(event) {
    event.stopPropagation();
    if (!onFill || !onRowsChange) return;
    const {
      columnIdx,
      rowIdx
    } = selectedRange;
    const sourceRow = rawRows[rowIdx];
    const targetRows = rawRows.slice(rowIdx + 1);
    const column = columns[columnIdx];
    const updatedTargetRows = onFill({
      columnKey: column.key,
      sourceRow,
      targetRows
    });
    const updatedRows = [];
    for (let i = rowIdx + 1; i < rawRows.length; i++) {
      const nextRow = updatedTargetRows[i - rowIdx - 1];
      updatedRows.push(nextRow);
    }
    patchRows({
      modifiedRows: updatedRows
    });
  }
  function handleEditorRowChange(row, commitChanges) {
    if (selectedRange.mode === RangeMode.SELECT) return;
    if (commitChanges) {
      var _gridRef$current5, _document$querySelect;
      if (row !== rows[selectedRange.rowIdx]) {
        updateSingleRow(row);
      }
      if ((_gridRef$current5 = gridRef.current) != null && _gridRef$current5.contains(document.activeElement) || (_document$querySelect = document.querySelector('.rdg-editor-archor')) != null && _document$querySelect.contains(document.activeElement)) {
        var _focusSinkRef$current5;
        (_focusSinkRef$current5 = focusSinkRef.current) == null || _focusSinkRef$current5.focus();
      }
      closeEditor();
    } else {
      updateSingleRow(row);
    }
  }
  function handleOnClose(commitChanges) {
    if (commitChanges) {
      commitEditorChanges();
    }
    closeEditor();
  }
  function closeEditor() {
    if (selectedRange.mode === RangeMode.SELECT) return;
    handleSelect({
      ...selectedRange,
      mode: RangeMode.SELECT,
      isUpdateIndex: true
    });
  }
  function scrollToCell({
    columnIdx,
    rowIdx
  }, force) {
    const {
      current
    } = gridRef;
    if (!current) return;
    if (typeof columnIdx === 'number' && columnIdx > lastFrozenColumnIndex) {
      var _rowIdx;
      columnIdx = Math.min(columns.length - 1, columnIdx || 0);
      (_rowIdx = rowIdx) != null ? _rowIdx : rowIdx = selectedRange.rowIdx;
      if (!isCellWithinRange({
        rowIdx,
        columnIdx,
        endColumnIdx: columnIdx,
        endRowIdx: rowIdx
      })) return;
      const {
        clientWidth
      } = current;
      const column = columns[columnIdx];
      const {
        left,
        width
      } = columnMetrics.get(column);
      let right = left + width;
      const isCellAtLeftBoundary = left < scrollLeft + totalFrozenColumnWidth;
      const isCellAtRightBoundary = right > clientWidth + scrollLeft;
      let nextScrollLeft = null;
      if (isCellAtLeftBoundary) {
        nextScrollLeft = left - totalFrozenColumnWidth;
      } else if (isCellAtRightBoundary) {
        nextScrollLeft = right - clientWidth;
      }
      !lodash.isNil(nextScrollLeft) && current.scrollTo({
        left: nextScrollLeft,
        behavior: 'auto'
      });
    }
    if (typeof rowIdx === 'number') {
      rowIdx = Math.min(rawRows.length, rowIdx || 0);
      const nextScrollTop = rowIdx * rowHeight;
      if (nextScrollTop < scrollTop || force) {
        current.scrollTo({
          top: nextScrollTop,
          behavior: 'auto'
        });
      } else if (nextScrollTop + rowHeight > scrollTop + clientHeight) {
        current.scrollTo({
          top: nextScrollTop + rowHeight - clientHeight,
          behavior: 'auto'
        });
      }
    }
  }
  function getNextPosition(key, ctrlKey, shiftKey) {
    const {
      columnIdx,
      rowIdx
    } = selectedRange;
    const isRowSelected = isCellWithinRange(selectedRange) && columnIdx === -1;
    switch (key) {
      case 'ArrowUp':
        return {
          columnIdx,
          rowIdx: rowIdx - 1
        };
      case 'ArrowDown':
        return {
          columnIdx,
          rowIdx: rowIdx + 1
        };
      case 'ArrowLeft':
        return {
          columnIdx: columnIdx - 1,
          rowIdx
        };
      case 'ArrowRight':
        return {
          columnIdx: columnIdx + 1,
          rowIdx
        };
      case 'Tab':
        if (selectedRange.columnIdx === -1 && selectedRange.rowIdx === -1) {
          return shiftKey ? {
            columnIdx: columns.length - 1,
            rowIdx: rows.length - 1
          } : {
            columnIdx: 0,
            rowIdx: 0
          };
        }
        return {
          columnIdx: columnIdx + (shiftKey ? -1 : 1),
          rowIdx
        };
      case 'Home':
        if (isRowSelected) return {
          columnIdx,
          rowIdx: 0
        };
        return ctrlKey ? {
          columnIdx: 1,
          rowIdx: 0
        } : {
          columnIdx: 1,
          rowIdx
        };
      case 'End':
        if (isRowSelected) return {
          columnIdx,
          rowIdx: rows.length - 1
        };
        return ctrlKey ? {
          columnIdx: columns.length - 1,
          rowIdx: rows.length - 1
        } : {
          columnIdx: columns.length - 1,
          rowIdx
        };
      case 'PageUp':
        return {
          columnIdx,
          rowIdx: rowIdx - Math.floor(clientHeight / rowHeight)
        };
      case 'PageDown':
        return {
          columnIdx,
          rowIdx: rowIdx + Math.floor(clientHeight / rowHeight)
        };
      default:
        return selectedRange;
    }
  }
  function navigate(event) {
    if (selectedRange.mode === RangeMode.EDIT) {
      var _columns$selectedRang2, _columns$selectedRang3;
      const onNavigation = (_columns$selectedRang2 = (_columns$selectedRang3 = columns[selectedRange.columnIdx].editorOptions) == null ? void 0 : _columns$selectedRang3.onNavigation) != null ? _columns$selectedRang2 : onEditorNavigation;
      if (!onNavigation(event)) return;
    }
    event.preventDefault();
    const {
      key,
      shiftKey
    } = event;
    let mode = cellNavigationMode;
    if (key === 'Tab') {
      if (canExitGrid({
        shiftKey,
        cellNavigationMode,
        columns,
        rowsCount: rows.length,
        selectedRange
      })) {
        var _focusSinkRef$current6;
        console.log('tab focus');
        (_focusSinkRef$current6 = focusSinkRef.current) == null || _focusSinkRef$current6.focus();
        commitEditorChanges();
        return;
      }
      mode = cellNavigationMode === 'NONE' ? 'CHANGE_ROW' : cellNavigationMode;
    }
    const ctrlKey = isCtrlKeyHeldDown(event);
    const nextPosition = getNextSelectedCellPosition({
      columns,
      rows,
      cellNavigationMode: mode,
      nextPosition: getNextPosition(key, ctrlKey, shiftKey)
    });
    selectCellAndCommitEdit(nextPosition);
    setTimeout(() => {
      var _focusSinkRef$current7;
      console.log('timeout focus');
      scrollToCell(nextPosition);
      (_focusSinkRef$current7 = focusSinkRef.current) == null || _focusSinkRef$current7.focus();
    });
  }
  function getDraggedOverCellIdx(currentRowIdx) {
    if (draggedOverRowIdx === undefined) return;
    const {
      rowIdx
    } = selectedRange;
    const isDraggedOver = rowIdx < draggedOverRowIdx ? rowIdx < currentRowIdx && currentRowIdx <= draggedOverRowIdx : rowIdx > currentRowIdx && currentRowIdx >= draggedOverRowIdx;
    return isDraggedOver ? selectedRange.columnIdx : undefined;
  }
  function getSelectedCellProps(rowIdx) {
    if (selectedRange.rowIdx !== rowIdx) return;
    if (selectedRange.mode === RangeMode.EDIT) {
      return {
        mode: RangeMode.EDIT,
        idx: selectedRange.columnIdx,
        onKeyDown: handleKeyDown,
        editorProps: {
          editorPortalTarget,
          rowHeight,
          onRowChange: handleEditorRowChange,
          onClose: handleOnClose
        }
      };
    }
    return {
      mode: RangeMode.SELECT,
      idx: selectedRange.columnIdx,
      onFocus: handleFocus,
      onKeyDown: handleKeyDown,
      dragHandleProps: enableCellDragAndDrop && isSelectedRangeEditable ? {
        onMouseDown: handleMouseDown,
        onDoubleClick: handleDoubleClick
      } : undefined
    };
  }
  React.useEffect(() => {
    var _gridRef$current6;
    const timerSet = new Set();
    if (isMouseInElement) return;
    const gridRect = (_gridRef$current6 = gridRef.current) == null ? void 0 : _gridRef$current6.getBoundingClientRect();
    if (mouseLeaveEvent && isMouseDown && gridRect) {
      const {
        x,
        y
      } = gridRect;
      const {
        clientX,
        clientY
      } = mouseLeaveEvent;
      const offsetX = clientX - x;
      const offsetY = clientY - y;
      const {
        endColumnIdx,
        endRowIdx
      } = selectedRange;
      if (offsetX <= 10) {
        const nextIdx = colVisibleStartIdx - 1;
        if (nextIdx > 0) {
          timerSet.add(setInterval(() => {
            scrollToCell({
              columnIdx: nextIdx
            });
            handleSelect({
              rowIdx: endRowIdx,
              columnIdx: nextIdx,
              isUpdateIndex: false
            });
          }, SCROLL_THROTTLE_TIME * 4));
        }
      }
      if (offsetX > gridWidth) {
        const nextIdx = colVisibleEndIdx + 1;
        if (nextIdx <= columns.length - 1) {
          timerSet.add(setInterval(() => {
            scrollToCell({
              columnIdx: nextIdx
            });
            handleSelect({
              rowIdx: endRowIdx,
              columnIdx: nextIdx,
              isUpdateIndex: false
            });
          }, SCROLL_THROTTLE_TIME * 4));
        }
      }
      if (offsetY <= 10) {
        const nextRowIdx = rowVisibleStartIdx - 1;
        if (nextRowIdx > -1) {
          timerSet.add(setInterval(() => {
            refContext.scrollToRow(nextRowIdx);
            handleSelect({
              rowIdx: nextRowIdx,
              columnIdx: endColumnIdx,
              isUpdateIndex: false
            });
          }, SCROLL_THROTTLE_TIME));
        }
      }
      if (offsetY >= gridHeight) {
        const nextRowIdx = rowVisibleEndIdx + 1;
        timerSet.add(setInterval(() => {
          refContext.scrollToRow(rowVisibleStartIdx + 1, true);
          if (nextRowIdx <= rows.length - 1) {
            handleSelect({
              rowIdx: rowVisibleEndIdx + 1,
              columnIdx: endColumnIdx,
              isUpdateIndex: false
            });
          }
        }, SCROLL_THROTTLE_TIME));
      }
    }
    return () => {
      timerSet.forEach(clearInterval);
    };
  }, [gridRef, isMouseInElement, selectedRange, mouseLeaveEvent, isMouseDown, rowVisibleStartIdx, rowVisibleEndIdx, colVisibleStartIdx, colVisibleEndIdx, gridWidth, gridHeight, handleSelect, refContext, rows, columns]);
  const getModifiedColumns = React.useCallback(row => {
    const key = rowKeyGetter(row);
    if (!(modifiedRowKeys != null && modifiedRowKeys.has(key))) return [];
    const modifiedColumns = [];
    Object.keys(row).forEach(columnKey => {
      var _row$_originRow;
      if (row[columnKey] !== (row == null || (_row$_originRow = row._originRow) == null ? void 0 : _row$_originRow[columnKey])) {
        modifiedColumns.push(columnKey);
      }
    });
    return modifiedColumns;
  }, [modifiedRowKeys, rowKeyGetter]);
  function getViewportRows() {
    const rowElements = [];
    const mainKey = [...(selectedRows || [])].pop();
    for (let rowIdx = rowOverscanStartIdx; rowIdx <= rowOverscanEndIdx; rowIdx++) {
      var _selectedRows$has;
      const row = rows[rowIdx];
      const top = rowIdx * rowHeight + totalHeaderHeight;
      const key = rowKeyGetter(row);
      let isRowSelected = false;
      isRowSelected = (_selectedRows$has = selectedRows == null ? void 0 : selectedRows.has(key)) != null ? _selectedRows$has : false;
      rowElements.push( /*#__PURE__*/jsxRuntime.jsx(RowRenderer, {
        "aria-rowindex": headerRowsCount + rowIdx + 1,
        "aria-selected": enableSelect ? isRowSelected : undefined,
        rowIdx: rowIdx,
        isLastRow: rowIdx === rows.length - 1,
        row: row,
        totalColumnWidth: totalColumnWidth,
        selectedColumns: selectedColumns,
        getModifiedColumns: getModifiedColumns,
        isAdd: newRowKeys == null ? void 0 : newRowKeys.has(key),
        isDeleted: deletedRowKeys == null ? void 0 : deletedRowKeys.has(key),
        enableRowRecord: enableRowRecord,
        lazyStore: lazyStore,
        setMouseDown: setMouseDown,
        viewportColumns: viewportColumns,
        columnMetrics: columnMetrics,
        isRowSelected: isRowSelected,
        isMainSelectedRow: mainKey === key,
        rowClass: rowClass,
        top: top,
        draggedOverCellIdx: getDraggedOverCellIdx(rowIdx),
        setDraggedOverRowIdx: isDragging ? setDraggedOverRowIdx : undefined,
        lastFrozenColumnIndex: lastFrozenColumnIndex,
        selectedCellProps: getSelectedCellProps(rowIdx),
        selectedRange: selectedRange,
        onRowChange: handleFormatterRowChangeLatest,
        onRowReorder: onRowReorder,
        onGridSelect: handleSelect
      }, key));
    }
    return rowElements;
  }
  React.useEffect(() => {
    if (selectedRange.columnIdx >= columns.length || selectedRange.rowIdx >= rows.length) {
      handleSelect(defaultSelectedRange);
      setDraggedOverRowIdx(undefined);
    }
  }, [selectedRange, columns.length, rows.length, handleSelect, setDraggedOverRowIdx]);
  const isHeaderDraging = useDragHeader(gridRef);
  return /*#__PURE__*/jsxRuntime.jsx(GridStore.Provider, {
    value: {
      gridRef: refContext
    },
    children: /*#__PURE__*/jsxRuntime.jsx(ContextMenuStore.Provider, {
      value: {
        getContextMenuConfig: getContextMenuConfig,
        ContextMenuRender: contextMenuRender,
        onAddRows: onAddRows,
        onDeleteRow: onDeleteRow,
        onRowReorder: onRowReorder,
        enableAddAction: enableAddRow,
        enableRowRecord: enableRowRecord,
        enableRowTools: enableRowTools,
        readonly: readonlyRef.current
      },
      children: /*#__PURE__*/jsxRuntime.jsxs(RowStore.Provider, {
        value: {
          showMenuRowIdx,
          setShowMenuRowIdx,
          topRowSet,
          changeTopRowSet
        },
        children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
          role: "grid",
          ...aria,
          onKeyDown: handleCopy,
          "aria-multiselectable": enableSelect ? true : undefined,
          "aria-colcount": columns.length,
          "aria-rowcount": headerRowsCount + rowsCount + summaryRowsCount,
          tabIndex: 0,
          className: clsx(rootClassname, className, isDragging && viewportDraggingClassname, theme === 'dark' && 'rdg-dark'),
          style: {
            ...style,
            overflowY: isHeaderDraging ? 'hidden' : 'auto',
            '--header-row-height': `${headerRowHeight}px`,
            '--filter-row-height': `${headerFiltersHeight}px`,
            '--row-width': `${totalColumnWidth}px`,
            '--row-height': `${rowHeight}px`,
            '--summary-row-height': `${summaryRowHeight}px`,
            ...layoutCssVars
          },
          ref: gridRef,
          onScroll: handleScroll,
          onContextMenu: handleContextMenu,
          children: [/*#__PURE__*/jsxRuntime.jsx(HeaderRow$1, {
            selectedRange: selectedRange,
            selectedColumns: selectedColumns,
            onGridSelect: handleSelect,
            columns: viewportColumns,
            onColumnResize: handleColumnResize,
            rowFilters: rowFilters,
            rowFilterOptions: rowFilterOptions,
            onFiltersChange: setRowFilters,
            allRowsSelected: (selectedRows == null ? void 0 : selectedRows.size) === rows.length,
            onColumnReorder: onColumnReorder,
            enableSortRow: enableSortRow,
            sortInfo: sortInfo,
            onSort: innerOnSort,
            lastFrozenColumnIndex: lastFrozenColumnIndex
          }), rows.length === 0 && EmptyRowsRenderer ? /*#__PURE__*/jsxRuntime.jsx(EmptyRowsRenderer, {}) : /*#__PURE__*/jsxRuntime.jsxs(jsxRuntime.Fragment, {
            children: [summaryRows == null ? void 0 : summaryRows.map((row, rowIdx) => /*#__PURE__*/jsxRuntime.jsx(SummaryRow$1, {
              "aria-rowindex": headerRowsCount + rowsCount + rowIdx + 1,
              rowIdx: rowIdx,
              isLastSummaryRow: rowIdx === summaryRows.length - 1,
              row: {
                ...row,
                [SELECT_COLUMN_KEY]: rows.findIndex(_row => rowKeyGetter(_row) === rowKeyGetter(row)) + 1
              },
              top: headerRowHeight + summaryRowHeight * rowIdx,
              viewportColumns: viewportColumns,
              lastFrozenColumnIndex: lastFrozenColumnIndex
            }, rowIdx)), /*#__PURE__*/jsxRuntime.jsx("div", {
              ref: focusSinkRef,
              tabIndex: 0,
              className: focusSinkClassname,
              onKeyDown: handleKeyDown,
              onFocus: onGridFocus
            }), /*#__PURE__*/jsxRuntime.jsx("div", {
              className: "rdg-pseudo-container",
              style: {
                height: Math.max(rows.length * rowHeight, clientHeight - 2)
              }
            }), getViewportRows()]
          }), contextMenuElement]
        }), /*#__PURE__*/jsxRuntime.jsx("div", {
          className: "rdg-editor-archor",
          style: {
            position: 'absolute',
            top: -scrollTop,
            left: -scrollLeft
          }
        })]
      })
    })
  });
}
const DataGrid$1 = /*#__PURE__*/React.forwardRef(DataGrid);

var css_248z = ".t1u15qzo{-webkit-appearance:none;-moz-appearance:none;-ms-appearance:none;appearance:none;background-color:var(--background-color);border:2px solid #ccc;box-sizing:border-box;color:var(--color);font-family:inherit;font-size:var(--font-size);height:100%;padding:0 6px;vertical-align:top;width:100%}.t1u15qzo:focus{border-color:var(--selection-color);outline:none}.t1u15qzo::-webkit-input-placeholder{color:#999;opacity:1}.t1u15qzo::-moz-placeholder{color:#999;opacity:1}.t1u15qzo:-ms-input-placeholder{color:#999;opacity:1}.t1u15qzo::placeholder{color:#999;opacity:1}";
styleInject(css_248z);

const textEditor = "t1u15qzo";
const textEditorClassname = `rdg-text-editor ${textEditor}`;
function autoFocusAndSelect(input) {
  input == null || input.focus();
  input == null || input.select();
}
function TextEditor({
  row,
  column,
  onRowChange,
  onClose
}) {
  return /*#__PURE__*/jsxRuntime.jsx("input", {
    className: textEditorClassname,
    ref: autoFocusAndSelect,
    value: row == null ? void 0 : row[column.key],
    onChange: event => onRowChange({
      ...row,
      [column.key]: event.target.value
    })
  });
}

function encodeCsvIden(str) {
  if (!str) {
    return '';
  }
  if (typeof str !== 'string') {
    str = str.toString();
  }
  return '"' + str.replace(/"/g, '""') + '"';
}
function exportCsv(gridRefContext) {
  const rangeData = getSelectedRangeData(gridRefContext);
  if (!rangeData) {
    return;
  }
  copyToClipboard(rangeData.map(data => {
    return data.map(item => {
      return encodeCsvIden(item);
    }).join(',');
  }).join('\r\n'), {
    format: 'text/plain'
  });
}

exports.Cell = MemoCell;
exports.Row = Row$1;
exports.SELECT_COLUMN_KEY = SELECT_COLUMN_KEY;
exports.SelectCellFormatter = SelectCellFormatter;
exports.SelectColumn = SelectColumn;
exports.SortableHeaderCell = SortableHeaderCell$1;
exports.TextEditor = TextEditor;
exports.ToggleGroupFormatter = ToggleGroupFormatter;
exports.ValueFormatter = ValueFormatter;
exports["default"] = DataGrid$1;
exports.defaultOnCopy = defaultOnCopy;
exports.defaultOnCopyCsv = exportCsv;
exports.getSelectedRangeData = getSelectedRangeData;
//# sourceMappingURL=bundle.cjs.map
