import type { CalculatedColumn, Column, Position, CellNavigationMode } from '../types';
interface IsSelectedCellEditableOpts<R, SR> {
    column: Column<R, SR>;
    row: R;
}
export declare function isCellEditable<R, SR>({ column, row }: IsSelectedCellEditableOpts<R, SR>): boolean;
interface GetNextSelectedCellPositionOpts<R, SR> {
    cellNavigationMode: CellNavigationMode;
    columns: readonly CalculatedColumn<R, SR>[];
    rows: readonly R[];
    nextPosition: Position;
}
export declare function getNextSelectedCellPosition<R, SR>({ cellNavigationMode, columns, rows, nextPosition, }: GetNextSelectedCellPositionOpts<R, SR>): Position;
interface CanExitGridOpts<R, SR> {
    cellNavigationMode: CellNavigationMode;
    columns: readonly CalculatedColumn<R, SR>[];
    rowsCount: number;
    selectedRange: Position;
    shiftKey: boolean;
}
export declare function canExitGrid<R, SR>({ cellNavigationMode, columns, rowsCount, selectedRange: { rowIdx, columnIdx }, shiftKey }: CanExitGridOpts<R, SR>): boolean;
export {};
//# sourceMappingURL=selectedCellUtils.d.ts.map